require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_AMD64_CPU_H_)) {
    eval 'sub _AMD64_CPU_H_ () {1;}' unless defined(&_AMD64_CPU_H_);
    if(defined(&__x86_64__)) {
	require 'x86/cpu.ph';
	if(defined(&_KERNEL)) {
	    if(defined(&__GNUC__)  && !defined(&_MODULE)) {
	    }
	    if(defined(&XENPV)) {
		eval 'sub CLKF_USERMODE {
		    my($frame) = @_;
    		    eval q(( &curcpu()-> &ci_xen_clockf_usermode));
		}' unless defined(&CLKF_USERMODE);
		eval 'sub CLKF_PC {
		    my($frame) = @_;
    		    eval q(( &curcpu()-> &ci_xen_clockf_pc));
		}' unless defined(&CLKF_PC);
	    } else {
		eval 'sub CLKF_USERMODE {
		    my($frame) = @_;
    		    eval q( &USERMODE(($frame)-> ($cf_if->{if_tf}->{tf_cs})));
		}' unless defined(&CLKF_USERMODE);
		eval 'sub CLKF_PC {
		    my($frame) = @_;
    		    eval q((($frame)-> ($cf_if->{if_tf}->{tf_rip})));
		}' unless defined(&CLKF_PC);
	    }
	    eval 'sub CLKF_INTR {
	        my($frame) = @_;
    		eval q(( &curcpu()-> &ci_idepth > 0));
	    }' unless defined(&CLKF_INTR);
	    eval 'sub LWP_PC {
	        my($l) = @_;
    		eval q((($l)-> ($l_md->{md_regs}->{tf_rip})));
	    }' unless defined(&LWP_PC);
	}
    } else {
	require 'i386/cpu.ph';
    }
}
1;
