require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_AMD64_FRAME_H_)) {
    eval 'sub _AMD64_FRAME_H_ () {1;}' unless defined(&_AMD64_FRAME_H_);
    if(defined(&__x86_64__)) {
	require 'sys/signal.ph';
	require 'sys/ucontext.ph';
	require 'machine/frame_regs.ph';
	eval 'sub tf {
	    my($reg, $REG, $idx) = @_;
    	    eval q( &uint64_t  &tf_$reg;);
	}' unless defined(&tf);
	undef(&tf) if defined(&tf);
	if(defined(&XEN)) {
	    eval 'sub _INTRFRAME_CS () { ($if_tf->{tf_cs});}' unless defined(&_INTRFRAME_CS);
	    eval 'sub _INTRFRAME_IP () { ($if_tf->{tf_rip});}' unless defined(&_INTRFRAME_IP);
	}
	if(defined(&_KERNEL)) {
	    eval 'sub lwp_trapframe {
	        my($l) = @_;
    		eval q((($l)-> ($l_md->{md_regs})));
	    }' unless defined(&lwp_trapframe);
	}
    } else {
	require 'i386/frame.ph';
    }
}
1;
