require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_NVMM_H_)) {
    eval 'sub _NVMM_H_ () {1;}' unless defined(&_NVMM_H_);
    require 'sys/types.ph';
    unless(defined(&_KERNEL)) {
	require 'stdbool.ph';
    }
    if(defined(&__x86_64__)) {
	require 'dev/nvmm/x86/nvmm_x86.ph';
    }
    eval 'sub NVMM_KERN_VERSION () {2;}' unless defined(&NVMM_KERN_VERSION);
    eval 'sub NVMM_MACH_CONF_LIBNVMM_BEGIN () {0;}' unless defined(&NVMM_MACH_CONF_LIBNVMM_BEGIN);
    eval 'sub NVMM_MACH_CONF_MI_BEGIN () {100;}' unless defined(&NVMM_MACH_CONF_MI_BEGIN);
    eval 'sub NVMM_MACH_CONF_MD_BEGIN () {200;}' unless defined(&NVMM_MACH_CONF_MD_BEGIN);
    eval 'sub NVMM_MACH_CONF_MD {
        my($op) = @_;
	    eval q(($op -  &NVMM_MACH_CONF_MD_BEGIN));
    }' unless defined(&NVMM_MACH_CONF_MD);
    eval 'sub NVMM_VCPU_CONF_LIBNVMM_BEGIN () {0;}' unless defined(&NVMM_VCPU_CONF_LIBNVMM_BEGIN);
    eval 'sub NVMM_VCPU_CONF_MI_BEGIN () {100;}' unless defined(&NVMM_VCPU_CONF_MI_BEGIN);
    eval 'sub NVMM_VCPU_CONF_MD_BEGIN () {200;}' unless defined(&NVMM_VCPU_CONF_MD_BEGIN);
    eval 'sub NVMM_VCPU_CONF_MD {
        my($op) = @_;
	    eval q(($op -  &NVMM_VCPU_CONF_MD_BEGIN));
    }' unless defined(&NVMM_VCPU_CONF_MD);
    eval 'sub NVMM_COMM_OFF {
        my($machid, $cpuid) = @_;
	    eval q((((( &uint64_t)$machid & 0xff) << 20) | ((( &uint64_t)$cpuid & 0xff) << 12)));
    }' unless defined(&NVMM_COMM_OFF);
    eval 'sub NVMM_COMM_MACHID {
        my($off) = @_;
	    eval q((($off >> 20) & 0xff));
    }' unless defined(&NVMM_COMM_MACHID);
    eval 'sub NVMM_COMM_CPUID {
        my($off) = @_;
	    eval q((($off >> 12) & 0xff));
    }' unless defined(&NVMM_COMM_CPUID);
    if(defined(&_KERNEL)) {
    }
}
1;
