require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_NVMM_IOCTL_H_)) {
    eval 'sub _NVMM_IOCTL_H_ () {1;}' unless defined(&_NVMM_IOCTL_H_);
    require 'sys/ioccom.ph';
    require 'dev/nvmm/nvmm.ph';
    eval 'sub NVMM_CTL_MACH_INFO () {0;}' unless defined(&NVMM_CTL_MACH_INFO);
    eval 'sub NVMM_IOC_CAPABILITY () { &_IOR (ord(\'N\'), 0, \'struct nvmm_ioc_capability\');}' unless defined(&NVMM_IOC_CAPABILITY);
    eval 'sub NVMM_IOC_MACHINE_CREATE () { &_IOWR(ord(\'N\'), 1, \'struct nvmm_ioc_machine_create\');}' unless defined(&NVMM_IOC_MACHINE_CREATE);
    eval 'sub NVMM_IOC_MACHINE_DESTROY () { &_IOW (ord(\'N\'), 2, \'struct nvmm_ioc_machine_destroy\');}' unless defined(&NVMM_IOC_MACHINE_DESTROY);
    eval 'sub NVMM_IOC_MACHINE_CONFIGURE () { &_IOW (ord(\'N\'), 3, \'struct nvmm_ioc_machine_configure\');}' unless defined(&NVMM_IOC_MACHINE_CONFIGURE);
    eval 'sub NVMM_IOC_VCPU_CREATE () { &_IOW (ord(\'N\'), 4, \'struct nvmm_ioc_vcpu_create\');}' unless defined(&NVMM_IOC_VCPU_CREATE);
    eval 'sub NVMM_IOC_VCPU_DESTROY () { &_IOW (ord(\'N\'), 5, \'struct nvmm_ioc_vcpu_destroy\');}' unless defined(&NVMM_IOC_VCPU_DESTROY);
    eval 'sub NVMM_IOC_VCPU_CONFIGURE () { &_IOW (ord(\'N\'), 6, \'struct nvmm_ioc_vcpu_configure\');}' unless defined(&NVMM_IOC_VCPU_CONFIGURE);
    eval 'sub NVMM_IOC_VCPU_SETSTATE () { &_IOW (ord(\'N\'), 7, \'struct nvmm_ioc_vcpu_setstate\');}' unless defined(&NVMM_IOC_VCPU_SETSTATE);
    eval 'sub NVMM_IOC_VCPU_GETSTATE () { &_IOW (ord(\'N\'), 8, \'struct nvmm_ioc_vcpu_getstate\');}' unless defined(&NVMM_IOC_VCPU_GETSTATE);
    eval 'sub NVMM_IOC_VCPU_INJECT () { &_IOW (ord(\'N\'), 9, \'struct nvmm_ioc_vcpu_inject\');}' unless defined(&NVMM_IOC_VCPU_INJECT);
    eval 'sub NVMM_IOC_VCPU_RUN () { &_IOWR(ord(\'N\'), 10, \'struct nvmm_ioc_vcpu_run\');}' unless defined(&NVMM_IOC_VCPU_RUN);
    eval 'sub NVMM_IOC_GPA_MAP () { &_IOW (ord(\'N\'), 11, \'struct nvmm_ioc_gpa_map\');}' unless defined(&NVMM_IOC_GPA_MAP);
    eval 'sub NVMM_IOC_GPA_UNMAP () { &_IOW (ord(\'N\'), 12, \'struct nvmm_ioc_gpa_unmap\');}' unless defined(&NVMM_IOC_GPA_UNMAP);
    eval 'sub NVMM_IOC_HVA_MAP () { &_IOW (ord(\'N\'), 13, \'struct nvmm_ioc_hva_map\');}' unless defined(&NVMM_IOC_HVA_MAP);
    eval 'sub NVMM_IOC_HVA_UNMAP () { &_IOW (ord(\'N\'), 14, \'struct nvmm_ioc_hva_unmap\');}' unless defined(&NVMM_IOC_HVA_UNMAP);
    eval 'sub NVMM_IOC_CTL () { &_IOW (ord(\'N\'), 20, \'struct nvmm_ioc_ctl\');}' unless defined(&NVMM_IOC_CTL);
}
1;
