require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_NVMM_X86_H_)) {
    eval 'sub _NVMM_X86_H_ () {1;}' unless defined(&_NVMM_X86_H_);
    unless(defined(&ASM_NVMM)) {
	eval 'sub NVMM_VCPU_EXIT_NONE () {0x;}' unless defined(&NVMM_VCPU_EXIT_NONE);
	eval 'sub NVMM_VCPU_EXIT_STOPPED () {0xfffffffffffffffe;}' unless defined(&NVMM_VCPU_EXIT_STOPPED);
	eval 'sub NVMM_VCPU_EXIT_INVALID () {0xffffffffffffffff;}' unless defined(&NVMM_VCPU_EXIT_INVALID);
	eval 'sub NVMM_VCPU_EXIT_MEMORY () {0x1;}' unless defined(&NVMM_VCPU_EXIT_MEMORY);
	eval 'sub NVMM_VCPU_EXIT_IO () {0x2;}' unless defined(&NVMM_VCPU_EXIT_IO);
	eval 'sub NVMM_VCPU_EXIT_SHUTDOWN () {0x1000;}' unless defined(&NVMM_VCPU_EXIT_SHUTDOWN);
	eval 'sub NVMM_VCPU_EXIT_INT_READY () {0x1001;}' unless defined(&NVMM_VCPU_EXIT_INT_READY);
	eval 'sub NVMM_VCPU_EXIT_NMI_READY () {0x1002;}' unless defined(&NVMM_VCPU_EXIT_NMI_READY);
	eval 'sub NVMM_VCPU_EXIT_HALTED () {0x1003;}' unless defined(&NVMM_VCPU_EXIT_HALTED);
	eval 'sub NVMM_VCPU_EXIT_TPR_CHANGED () {0x1004;}' unless defined(&NVMM_VCPU_EXIT_TPR_CHANGED);
	eval 'sub NVMM_VCPU_EXIT_RDMSR () {0x2000;}' unless defined(&NVMM_VCPU_EXIT_RDMSR);
	eval 'sub NVMM_VCPU_EXIT_WRMSR () {0x2001;}' unless defined(&NVMM_VCPU_EXIT_WRMSR);
	eval 'sub NVMM_VCPU_EXIT_MONITOR () {0x2002;}' unless defined(&NVMM_VCPU_EXIT_MONITOR);
	eval 'sub NVMM_VCPU_EXIT_MWAIT () {0x2003;}' unless defined(&NVMM_VCPU_EXIT_MWAIT);
	eval 'sub NVMM_VCPU_EXIT_CPUID () {0x2004;}' unless defined(&NVMM_VCPU_EXIT_CPUID);
	eval 'sub NVMM_VCPU_EVENT_EXCP () {0;}' unless defined(&NVMM_VCPU_EVENT_EXCP);
	eval 'sub NVMM_VCPU_EVENT_INTR () {1;}' unless defined(&NVMM_VCPU_EVENT_INTR);
	eval 'sub NVMM_CAP_ARCH_VCPU_CONF_CPUID () { &__BIT(0);}' unless defined(&NVMM_CAP_ARCH_VCPU_CONF_CPUID);
	eval 'sub NVMM_CAP_ARCH_VCPU_CONF_TPR () { &__BIT(1);}' unless defined(&NVMM_CAP_ARCH_VCPU_CONF_TPR);
    }
    eval 'sub NVMM_X64_SEG_ES () {0;}' unless defined(&NVMM_X64_SEG_ES);
    eval 'sub NVMM_X64_SEG_CS () {1;}' unless defined(&NVMM_X64_SEG_CS);
    eval 'sub NVMM_X64_SEG_SS () {2;}' unless defined(&NVMM_X64_SEG_SS);
    eval 'sub NVMM_X64_SEG_DS () {3;}' unless defined(&NVMM_X64_SEG_DS);
    eval 'sub NVMM_X64_SEG_FS () {4;}' unless defined(&NVMM_X64_SEG_FS);
    eval 'sub NVMM_X64_SEG_GS () {5;}' unless defined(&NVMM_X64_SEG_GS);
    eval 'sub NVMM_X64_SEG_GDT () {6;}' unless defined(&NVMM_X64_SEG_GDT);
    eval 'sub NVMM_X64_SEG_IDT () {7;}' unless defined(&NVMM_X64_SEG_IDT);
    eval 'sub NVMM_X64_SEG_LDT () {8;}' unless defined(&NVMM_X64_SEG_LDT);
    eval 'sub NVMM_X64_SEG_TR () {9;}' unless defined(&NVMM_X64_SEG_TR);
    eval 'sub NVMM_X64_NSEG () {10;}' unless defined(&NVMM_X64_NSEG);
    eval 'sub NVMM_X64_GPR_RAX () {0;}' unless defined(&NVMM_X64_GPR_RAX);
    eval 'sub NVMM_X64_GPR_RCX () {1;}' unless defined(&NVMM_X64_GPR_RCX);
    eval 'sub NVMM_X64_GPR_RDX () {2;}' unless defined(&NVMM_X64_GPR_RDX);
    eval 'sub NVMM_X64_GPR_RBX () {3;}' unless defined(&NVMM_X64_GPR_RBX);
    eval 'sub NVMM_X64_GPR_RSP () {4;}' unless defined(&NVMM_X64_GPR_RSP);
    eval 'sub NVMM_X64_GPR_RBP () {5;}' unless defined(&NVMM_X64_GPR_RBP);
    eval 'sub NVMM_X64_GPR_RSI () {6;}' unless defined(&NVMM_X64_GPR_RSI);
    eval 'sub NVMM_X64_GPR_RDI () {7;}' unless defined(&NVMM_X64_GPR_RDI);
    eval 'sub NVMM_X64_GPR_R8 () {8;}' unless defined(&NVMM_X64_GPR_R8);
    eval 'sub NVMM_X64_GPR_R9 () {9;}' unless defined(&NVMM_X64_GPR_R9);
    eval 'sub NVMM_X64_GPR_R10 () {10;}' unless defined(&NVMM_X64_GPR_R10);
    eval 'sub NVMM_X64_GPR_R11 () {11;}' unless defined(&NVMM_X64_GPR_R11);
    eval 'sub NVMM_X64_GPR_R12 () {12;}' unless defined(&NVMM_X64_GPR_R12);
    eval 'sub NVMM_X64_GPR_R13 () {13;}' unless defined(&NVMM_X64_GPR_R13);
    eval 'sub NVMM_X64_GPR_R14 () {14;}' unless defined(&NVMM_X64_GPR_R14);
    eval 'sub NVMM_X64_GPR_R15 () {15;}' unless defined(&NVMM_X64_GPR_R15);
    eval 'sub NVMM_X64_GPR_RIP () {16;}' unless defined(&NVMM_X64_GPR_RIP);
    eval 'sub NVMM_X64_GPR_RFLAGS () {17;}' unless defined(&NVMM_X64_GPR_RFLAGS);
    eval 'sub NVMM_X64_NGPR () {18;}' unless defined(&NVMM_X64_NGPR);
    eval 'sub NVMM_X64_CR_CR0 () {0;}' unless defined(&NVMM_X64_CR_CR0);
    eval 'sub NVMM_X64_CR_CR2 () {1;}' unless defined(&NVMM_X64_CR_CR2);
    eval 'sub NVMM_X64_CR_CR3 () {2;}' unless defined(&NVMM_X64_CR_CR3);
    eval 'sub NVMM_X64_CR_CR4 () {3;}' unless defined(&NVMM_X64_CR_CR4);
    eval 'sub NVMM_X64_CR_CR8 () {4;}' unless defined(&NVMM_X64_CR_CR8);
    eval 'sub NVMM_X64_CR_XCR0 () {5;}' unless defined(&NVMM_X64_CR_XCR0);
    eval 'sub NVMM_X64_NCR () {6;}' unless defined(&NVMM_X64_NCR);
    eval 'sub NVMM_X64_DR_DR0 () {0;}' unless defined(&NVMM_X64_DR_DR0);
    eval 'sub NVMM_X64_DR_DR1 () {1;}' unless defined(&NVMM_X64_DR_DR1);
    eval 'sub NVMM_X64_DR_DR2 () {2;}' unless defined(&NVMM_X64_DR_DR2);
    eval 'sub NVMM_X64_DR_DR3 () {3;}' unless defined(&NVMM_X64_DR_DR3);
    eval 'sub NVMM_X64_DR_DR6 () {4;}' unless defined(&NVMM_X64_DR_DR6);
    eval 'sub NVMM_X64_DR_DR7 () {5;}' unless defined(&NVMM_X64_DR_DR7);
    eval 'sub NVMM_X64_NDR () {6;}' unless defined(&NVMM_X64_NDR);
    eval 'sub NVMM_X64_MSR_EFER () {0;}' unless defined(&NVMM_X64_MSR_EFER);
    eval 'sub NVMM_X64_MSR_STAR () {1;}' unless defined(&NVMM_X64_MSR_STAR);
    eval 'sub NVMM_X64_MSR_LSTAR () {2;}' unless defined(&NVMM_X64_MSR_LSTAR);
    eval 'sub NVMM_X64_MSR_CSTAR () {3;}' unless defined(&NVMM_X64_MSR_CSTAR);
    eval 'sub NVMM_X64_MSR_SFMASK () {4;}' unless defined(&NVMM_X64_MSR_SFMASK);
    eval 'sub NVMM_X64_MSR_KERNELGSBASE () {5;}' unless defined(&NVMM_X64_MSR_KERNELGSBASE);
    eval 'sub NVMM_X64_MSR_SYSENTER_CS () {6;}' unless defined(&NVMM_X64_MSR_SYSENTER_CS);
    eval 'sub NVMM_X64_MSR_SYSENTER_ESP () {7;}' unless defined(&NVMM_X64_MSR_SYSENTER_ESP);
    eval 'sub NVMM_X64_MSR_SYSENTER_EIP () {8;}' unless defined(&NVMM_X64_MSR_SYSENTER_EIP);
    eval 'sub NVMM_X64_MSR_PAT () {9;}' unless defined(&NVMM_X64_MSR_PAT);
    eval 'sub NVMM_X64_MSR_TSC () {10;}' unless defined(&NVMM_X64_MSR_TSC);
    eval 'sub NVMM_X64_NMSR () {11;}' unless defined(&NVMM_X64_NMSR);
    unless(defined(&ASM_NVMM)) {
	require 'sys/types.ph';
	require 'x86/cpu_extended_state.ph';
	eval 'sub NVMM_X64_STATE_SEGS () {0x1;}' unless defined(&NVMM_X64_STATE_SEGS);
	eval 'sub NVMM_X64_STATE_GPRS () {0x2;}' unless defined(&NVMM_X64_STATE_GPRS);
	eval 'sub NVMM_X64_STATE_CRS () {0x4;}' unless defined(&NVMM_X64_STATE_CRS);
	eval 'sub NVMM_X64_STATE_DRS () {0x8;}' unless defined(&NVMM_X64_STATE_DRS);
	eval 'sub NVMM_X64_STATE_MSRS () {0x10;}' unless defined(&NVMM_X64_STATE_MSRS);
	eval 'sub NVMM_X64_STATE_INTR () {0x20;}' unless defined(&NVMM_X64_STATE_INTR);
	eval 'sub NVMM_X64_STATE_FPU () {0x40;}' unless defined(&NVMM_X64_STATE_FPU);
	eval 'sub NVMM_X64_STATE_ALL () {( &NVMM_X64_STATE_SEGS |  &NVMM_X64_STATE_GPRS |  &NVMM_X64_STATE_CRS |  &NVMM_X64_STATE_DRS |  &NVMM_X64_STATE_MSRS |  &NVMM_X64_STATE_INTR |  &NVMM_X64_STATE_FPU);}' unless defined(&NVMM_X64_STATE_ALL);
	eval 'sub NVMM_VCPU_CONF_CPUID () { &NVMM_VCPU_CONF_MD_BEGIN;}' unless defined(&NVMM_VCPU_CONF_CPUID);
	eval 'sub NVMM_VCPU_CONF_TPR () {( &NVMM_VCPU_CONF_MD_BEGIN + 1);}' unless defined(&NVMM_VCPU_CONF_TPR);
	eval 'sub nvmm_vcpu_exit () { &nvmm_x86_exit;}' unless defined(&nvmm_vcpu_exit);
	eval 'sub nvmm_vcpu_event () { &nvmm_x86_event;}' unless defined(&nvmm_vcpu_event);
	eval 'sub nvmm_vcpu_state () { &nvmm_x64_state;}' unless defined(&nvmm_vcpu_state);
	if(defined(&_KERNEL)) {
	    eval 'sub NVMM_X86_MACH_NCONF () {0;}' unless defined(&NVMM_X86_MACH_NCONF);
	    eval 'sub NVMM_X86_VCPU_NCONF () {2;}' unless defined(&NVMM_X86_VCPU_NCONF);
	}
    }
}
1;
