require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_IMMINTRIN_H_INCLUDED)) {
    die("Never use <avxintrin.h> directly; include <immintrin.h> instead.");
}
unless(defined(&_AVXINTRIN_H_INCLUDED)) {
    eval 'sub _AVXINTRIN_H_INCLUDED () {1;}' unless defined(&_AVXINTRIN_H_INCLUDED);
    unless(defined(&__AVX__)) {
	eval 'sub __DISABLE_AVX__ () {1;}' unless defined(&__DISABLE_AVX__);
    }
    eval 'sub _CMP_EQ_OQ () {0x;}' unless defined(&_CMP_EQ_OQ);
    eval 'sub _CMP_LT_OS () {0x1;}' unless defined(&_CMP_LT_OS);
    eval 'sub _CMP_LE_OS () {0x2;}' unless defined(&_CMP_LE_OS);
    eval 'sub _CMP_UNORD_Q () {0x3;}' unless defined(&_CMP_UNORD_Q);
    eval 'sub _CMP_NEQ_UQ () {0x4;}' unless defined(&_CMP_NEQ_UQ);
    eval 'sub _CMP_NLT_US () {0x5;}' unless defined(&_CMP_NLT_US);
    eval 'sub _CMP_NLE_US () {0x6;}' unless defined(&_CMP_NLE_US);
    eval 'sub _CMP_ORD_Q () {0x7;}' unless defined(&_CMP_ORD_Q);
    eval 'sub _CMP_EQ_UQ () {0x8;}' unless defined(&_CMP_EQ_UQ);
    eval 'sub _CMP_NGE_US () {0x9;}' unless defined(&_CMP_NGE_US);
    eval 'sub _CMP_NGT_US () {0xa;}' unless defined(&_CMP_NGT_US);
    eval 'sub _CMP_FALSE_OQ () {0xb;}' unless defined(&_CMP_FALSE_OQ);
    eval 'sub _CMP_NEQ_OQ () {0xc;}' unless defined(&_CMP_NEQ_OQ);
    eval 'sub _CMP_GE_OS () {0xd;}' unless defined(&_CMP_GE_OS);
    eval 'sub _CMP_GT_OS () {0xe;}' unless defined(&_CMP_GT_OS);
    eval 'sub _CMP_TRUE_UQ () {0xf;}' unless defined(&_CMP_TRUE_UQ);
    eval 'sub _CMP_EQ_OS () {0x10;}' unless defined(&_CMP_EQ_OS);
    eval 'sub _CMP_LT_OQ () {0x11;}' unless defined(&_CMP_LT_OQ);
    eval 'sub _CMP_LE_OQ () {0x12;}' unless defined(&_CMP_LE_OQ);
    eval 'sub _CMP_UNORD_S () {0x13;}' unless defined(&_CMP_UNORD_S);
    eval 'sub _CMP_NEQ_US () {0x14;}' unless defined(&_CMP_NEQ_US);
    eval 'sub _CMP_NLT_UQ () {0x15;}' unless defined(&_CMP_NLT_UQ);
    eval 'sub _CMP_NLE_UQ () {0x16;}' unless defined(&_CMP_NLE_UQ);
    eval 'sub _CMP_ORD_S () {0x17;}' unless defined(&_CMP_ORD_S);
    eval 'sub _CMP_EQ_US () {0x18;}' unless defined(&_CMP_EQ_US);
    eval 'sub _CMP_NGE_UQ () {0x19;}' unless defined(&_CMP_NGE_UQ);
    eval 'sub _CMP_NGT_UQ () {0x1a;}' unless defined(&_CMP_NGT_UQ);
    eval 'sub _CMP_FALSE_OS () {0x1b;}' unless defined(&_CMP_FALSE_OS);
    eval 'sub _CMP_NEQ_OS () {0x1c;}' unless defined(&_CMP_NEQ_OS);
    eval 'sub _CMP_GE_OQ () {0x1d;}' unless defined(&_CMP_GE_OQ);
    eval 'sub _CMP_GT_OQ () {0x1e;}' unless defined(&_CMP_GT_OQ);
    eval 'sub _CMP_TRUE_US () {0x1f;}' unless defined(&_CMP_TRUE_US);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_add_pd ( &__m256d  &__A,  &__m256d  &__B) { ( &__m256d) (( &__v4df) &__A + ( &__v4df) &__B); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_add_ps ( &__m256  &__A,  &__m256  &__B) { ( &__m256) (( &__v8sf) &__A + ( &__v8sf) &__B); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_addsub_pd ( &__m256d  &__A,  &__m256d  &__B) { ( &__m256d)  &__builtin_ia32_addsubpd256 (( &__v4df) &__A, ( &__v4df) &__B); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_addsub_ps ( &__m256  &__A,  &__m256  &__B) { ( &__m256)  &__builtin_ia32_addsubps256 (( &__v8sf) &__A, ( &__v8sf) &__B); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_and_pd ( &__m256d  &__A,  &__m256d  &__B) { ( &__m256d)  &__builtin_ia32_andpd256 (( &__v4df) &__A, ( &__v4df) &__B); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_and_ps ( &__m256  &__A,  &__m256  &__B) { ( &__m256)  &__builtin_ia32_andps256 (( &__v8sf) &__A, ( &__v8sf) &__B); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_andnot_pd ( &__m256d  &__A,  &__m256d  &__B) { ( &__m256d)  &__builtin_ia32_andnpd256 (( &__v4df) &__A, ( &__v4df) &__B); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_andnot_ps ( &__m256  &__A,  &__m256  &__B) { ( &__m256)  &__builtin_ia32_andnps256 (( &__v8sf) &__A, ( &__v8sf) &__B); });
    }' unless defined(&__attribute__);
    if(defined(&__OPTIMIZE__)) {
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_blend_pd ( &__m256d  &__X,  &__m256d  &__Y,  &const \'int\'  &__M) { ( &__m256d)  &__builtin_ia32_blendpd256 (( &__v4df) &__X, ( &__v4df) &__Y,  &__M); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_blend_ps ( &__m256  &__X,  &__m256  &__Y,  &const \'int\'  &__M) { ( &__m256)  &__builtin_ia32_blendps256 (( &__v8sf) &__X, ( &__v8sf) &__Y,  &__M); });
	}' unless defined(&__attribute__);
    } else {
	eval 'sub _mm256_blend_pd {
	    my($X, $Y, $M) = @_;
    	    eval q((( &__m256d)  &__builtin_ia32_blendpd256 (( &__v4df)( &__m256d)($X), ( &__v4df)( &__m256d), ($M))));
	}' unless defined(&_mm256_blend_pd);
	eval 'sub _mm256_blend_ps {
	    my($X, $Y, $M) = @_;
    	    eval q((( &__m256)  &__builtin_ia32_blendps256 (( &__v8sf)( &__m256)($X), ( &__v8sf)( &__m256), ($M))));
	}' unless defined(&_mm256_blend_ps);
    }
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_blendv_pd ( &__m256d  &__X,  &__m256d  &__Y,  &__m256d  &__M) { ( &__m256d)  &__builtin_ia32_blendvpd256 (( &__v4df) &__X, ( &__v4df) &__Y, ( &__v4df) &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_blendv_ps ( &__m256  &__X,  &__m256  &__Y,  &__m256  &__M) { ( &__m256)  &__builtin_ia32_blendvps256 (( &__v8sf) &__X, ( &__v8sf) &__Y, ( &__v8sf) &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_div_pd ( &__m256d  &__A,  &__m256d  &__B) { ( &__m256d) (( &__v4df) &__A / ( &__v4df) &__B); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_div_ps ( &__m256  &__A,  &__m256  &__B) { ( &__m256) (( &__v8sf) &__A / ( &__v8sf) &__B); });
    }' unless defined(&__attribute__);
    if(defined(&__OPTIMIZE__)) {
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_dp_ps ( &__m256  &__X,  &__m256  &__Y,  &const \'int\'  &__M) { ( &__m256)  &__builtin_ia32_dpps256 (( &__v8sf) &__X, ( &__v8sf) &__Y,  &__M); });
	}' unless defined(&__attribute__);
    } else {
	eval 'sub _mm256_dp_ps {
	    my($X, $Y, $M) = @_;
    	    eval q((( &__m256)  &__builtin_ia32_dpps256 (( &__v8sf)( &__m256)($X), ( &__v8sf)( &__m256), ($M))));
	}' unless defined(&_mm256_dp_ps);
    }
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_hadd_pd ( &__m256d  &__X,  &__m256d  &__Y) { ( &__m256d)  &__builtin_ia32_haddpd256 (( &__v4df) &__X, ( &__v4df) &__Y); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_hadd_ps ( &__m256  &__X,  &__m256  &__Y) { ( &__m256)  &__builtin_ia32_haddps256 (( &__v8sf) &__X, ( &__v8sf) &__Y); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_hsub_pd ( &__m256d  &__X,  &__m256d  &__Y) { ( &__m256d)  &__builtin_ia32_hsubpd256 (( &__v4df) &__X, ( &__v4df) &__Y); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_hsub_ps ( &__m256  &__X,  &__m256  &__Y) { ( &__m256)  &__builtin_ia32_hsubps256 (( &__v8sf) &__X, ( &__v8sf) &__Y); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_max_pd ( &__m256d  &__A,  &__m256d  &__B) { ( &__m256d)  &__builtin_ia32_maxpd256 (( &__v4df) &__A, ( &__v4df) &__B); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_max_ps ( &__m256  &__A,  &__m256  &__B) { ( &__m256)  &__builtin_ia32_maxps256 (( &__v8sf) &__A, ( &__v8sf) &__B); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_min_pd ( &__m256d  &__A,  &__m256d  &__B) { ( &__m256d)  &__builtin_ia32_minpd256 (( &__v4df) &__A, ( &__v4df) &__B); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_min_ps ( &__m256  &__A,  &__m256  &__B) { ( &__m256)  &__builtin_ia32_minps256 (( &__v8sf) &__A, ( &__v8sf) &__B); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_mul_pd ( &__m256d  &__A,  &__m256d  &__B) { ( &__m256d) (( &__v4df) &__A * ( &__v4df) &__B); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_mul_ps ( &__m256  &__A,  &__m256  &__B) { ( &__m256) (( &__v8sf) &__A * ( &__v8sf) &__B); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_or_pd ( &__m256d  &__A,  &__m256d  &__B) { ( &__m256d)  &__builtin_ia32_orpd256 (( &__v4df) &__A, ( &__v4df) &__B); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_or_ps ( &__m256  &__A,  &__m256  &__B) { ( &__m256)  &__builtin_ia32_orps256 (( &__v8sf) &__A, ( &__v8sf) &__B); });
    }' unless defined(&__attribute__);
    if(defined(&__OPTIMIZE__)) {
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_shuffle_pd ( &__m256d  &__A,  &__m256d  &__B,  &const \'int\'  &__mask) { ( &__m256d)  &__builtin_ia32_shufpd256 (( &__v4df) &__A, ( &__v4df) &__B,  &__mask); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_shuffle_ps ( &__m256  &__A,  &__m256  &__B,  &const \'int\'  &__mask) { ( &__m256)  &__builtin_ia32_shufps256 (( &__v8sf) &__A, ( &__v8sf) &__B,  &__mask); });
	}' unless defined(&__attribute__);
    } else {
	eval 'sub _mm256_shuffle_pd {
	    my($A, $B, $N) = @_;
    	    eval q((( &__m256d) &__builtin_ia32_shufpd256 (( &__v4df)( &__m256d)($A), ( &__v4df)( &__m256d), ($N))));
	}' unless defined(&_mm256_shuffle_pd);
	eval 'sub _mm256_shuffle_ps {
	    my($A, $B, $N) = @_;
    	    eval q((( &__m256)  &__builtin_ia32_shufps256 (( &__v8sf)( &__m256)($A), ( &__v8sf)( &__m256), ($N))));
	}' unless defined(&_mm256_shuffle_ps);
    }
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_sub_pd ( &__m256d  &__A,  &__m256d  &__B) { ( &__m256d) (( &__v4df) &__A - ( &__v4df) &__B); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_sub_ps ( &__m256  &__A,  &__m256  &__B) { ( &__m256) (( &__v8sf) &__A - ( &__v8sf) &__B); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_xor_pd ( &__m256d  &__A,  &__m256d  &__B) { ( &__m256d)  &__builtin_ia32_xorpd256 (( &__v4df) &__A, ( &__v4df) &__B); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_xor_ps ( &__m256  &__A,  &__m256  &__B) { ( &__m256)  &__builtin_ia32_xorps256 (( &__v8sf) &__A, ( &__v8sf) &__B); });
    }' unless defined(&__attribute__);
    if(defined(&__OPTIMIZE__)) {
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_cmp_pd ( &__m128d  &__X,  &__m128d  &__Y,  &const \'int\'  &__P) { ( &__m128d)  &__builtin_ia32_cmppd (( &__v2df) &__X, ( &__v2df) &__Y,  &__P); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_cmp_ps ( &__m128  &__X,  &__m128  &__Y,  &const \'int\'  &__P) { ( &__m128)  &__builtin_ia32_cmpps (( &__v4sf) &__X, ( &__v4sf) &__Y,  &__P); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_cmp_pd ( &__m256d  &__X,  &__m256d  &__Y,  &const \'int\'  &__P) { ( &__m256d)  &__builtin_ia32_cmppd256 (( &__v4df) &__X, ( &__v4df) &__Y,  &__P); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_cmp_ps ( &__m256  &__X,  &__m256  &__Y,  &const \'int\'  &__P) { ( &__m256)  &__builtin_ia32_cmpps256 (( &__v8sf) &__X, ( &__v8sf) &__Y,  &__P); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_cmp_sd ( &__m128d  &__X,  &__m128d  &__Y,  &const \'int\'  &__P) { ( &__m128d)  &__builtin_ia32_cmpsd (( &__v2df) &__X, ( &__v2df) &__Y,  &__P); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_cmp_ss ( &__m128  &__X,  &__m128  &__Y,  &const \'int\'  &__P) { ( &__m128)  &__builtin_ia32_cmpss (( &__v4sf) &__X, ( &__v4sf) &__Y,  &__P); });
	}' unless defined(&__attribute__);
    } else {
	eval 'sub _mm_cmp_pd {
	    my($X, $Y, $P) = @_;
    	    eval q((( &__m128d)  &__builtin_ia32_cmppd (( &__v2df)( &__m128d)($X), ( &__v2df)( &__m128d), ($P))));
	}' unless defined(&_mm_cmp_pd);
	eval 'sub _mm_cmp_ps {
	    my($X, $Y, $P) = @_;
    	    eval q((( &__m128)  &__builtin_ia32_cmpps (( &__v4sf)( &__m128)($X), ( &__v4sf)( &__m128), ($P))));
	}' unless defined(&_mm_cmp_ps);
	eval 'sub _mm256_cmp_pd {
	    my($X, $Y, $P) = @_;
    	    eval q((( &__m256d)  &__builtin_ia32_cmppd256 (( &__v4df)( &__m256d)($X), ( &__v4df)( &__m256d), ($P))));
	}' unless defined(&_mm256_cmp_pd);
	eval 'sub _mm256_cmp_ps {
	    my($X, $Y, $P) = @_;
    	    eval q((( &__m256)  &__builtin_ia32_cmpps256 (( &__v8sf)( &__m256)($X), ( &__v8sf)( &__m256), ($P))));
	}' unless defined(&_mm256_cmp_ps);
	eval 'sub _mm_cmp_sd {
	    my($X, $Y, $P) = @_;
    	    eval q((( &__m128d)  &__builtin_ia32_cmpsd (( &__v2df)( &__m128d)($X), ( &__v2df)( &__m128d), ($P))));
	}' unless defined(&_mm_cmp_sd);
	eval 'sub _mm_cmp_ss {
	    my($X, $Y, $P) = @_;
    	    eval q((( &__m128)  &__builtin_ia32_cmpss (( &__v4sf)( &__m128)($X), ( &__v4sf)( &__m128), ($P))));
	}' unless defined(&_mm_cmp_ss);
    }
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_cvtepi32_pd ( &__m128i  &__A) { ( &__m256d) &__builtin_ia32_cvtdq2pd256 (( &__v4si)  &__A); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_cvtepi32_ps ( &__m256i  &__A) { ( &__m256) &__builtin_ia32_cvtdq2ps256 (( &__v8si)  &__A); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_cvtpd_ps ( &__m256d  &__A) { ( &__m128) &__builtin_ia32_cvtpd2ps256 (( &__v4df)  &__A); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_cvtps_epi32 ( &__m256  &__A) { ( &__m256i) &__builtin_ia32_cvtps2dq256 (( &__v8sf)  &__A); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_cvtps_pd ( &__m128  &__A) { ( &__m256d) &__builtin_ia32_cvtps2pd256 (( &__v4sf)  &__A); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_cvttpd_epi32 ( &__m256d  &__A) { ( &__m128i) &__builtin_ia32_cvttpd2dq256 (( &__v4df)  &__A); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_cvtpd_epi32 ( &__m256d  &__A) { ( &__m128i) &__builtin_ia32_cvtpd2dq256 (( &__v4df)  &__A); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_cvttps_epi32 ( &__m256  &__A) { ( &__m256i) &__builtin_ia32_cvttps2dq256 (( &__v8sf)  &__A); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_cvtsd_f64 ( &__m256d  &__A) {  $__A[0]; });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_cvtss_f32 ( &__m256  &__A) {  $__A[0]; });
    }' unless defined(&__attribute__);
    if(defined(&__OPTIMIZE__)) {
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_extractf128_pd ( &__m256d  &__X,  &const \'int\'  &__N) { ( &__m128d)  &__builtin_ia32_vextractf128_pd256 (( &__v4df) &__X,  &__N); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_extractf128_ps ( &__m256  &__X,  &const \'int\'  &__N) { ( &__m128)  &__builtin_ia32_vextractf128_ps256 (( &__v8sf) &__X,  &__N); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_extractf128_si256 ( &__m256i  &__X,  &const \'int\'  &__N) { ( &__m128i)  &__builtin_ia32_vextractf128_si256 (( &__v8si) &__X,  &__N); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_extract_epi32 ( &__m256i  &__X, \'int\'  &const  &__N) {  &__m128i  &__Y =  &_mm256_extractf128_si256 ( &__X,  &__N >> 2);  &_mm_extract_epi32 ( &__Y,  &__N % 4); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_extract_epi16 ( &__m256i  &__X, \'int\'  &const  &__N) {  &__m128i  &__Y =  &_mm256_extractf128_si256 ( &__X,  &__N >> 3);  &_mm_extract_epi16 ( &__Y,  &__N % 8); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_extract_epi8 ( &__m256i  &__X, \'int\'  &const  &__N) {  &__m128i  &__Y =  &_mm256_extractf128_si256 ( &__X,  &__N >> 4);  &_mm_extract_epi8 ( &__Y,  &__N % 16); });
	}' unless defined(&__attribute__);
	if(defined(&__x86_64__)) {
	    eval 'sub __attribute__ () {
	        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_extract_epi64 ( &__m256i  &__X,  &const \'int\'  &__N) {  &__m128i  &__Y =  &_mm256_extractf128_si256 ( &__X,  &__N >> 1);  &_mm_extract_epi64 ( &__Y,  &__N % 2); });
	    }' unless defined(&__attribute__);
	}
    } else {
	eval 'sub _mm256_extractf128_pd {
	    my($X, $N) = @_;
    	    eval q((( &__m128d)  &__builtin_ia32_vextractf128_pd256 (( &__v4df)( &__m256d), ($N))));
	}' unless defined(&_mm256_extractf128_pd);
	eval 'sub _mm256_extractf128_ps {
	    my($X, $N) = @_;
    	    eval q((( &__m128)  &__builtin_ia32_vextractf128_ps256 (( &__v8sf)( &__m256), ($N))));
	}' unless defined(&_mm256_extractf128_ps);
	eval 'sub _mm256_extractf128_si256 {
	    my($X, $N) = @_;
    	    eval q((( &__m128i)  &__builtin_ia32_vextractf128_si256 (( &__v8si)( &__m256i), ($N))));
	}' unless defined(&_mm256_extractf128_si256);
	eval 'sub _mm256_extract_epi32 {
	    my($X, $N) = @_;
    	    eval q(( &__extension__ ({  &__m128i  &__Y =  &_mm256_extractf128_si256 (($X), ($N) >> 2);  &_mm_extract_epi32 ( &__Y, ($N) % 4); })));
	}' unless defined(&_mm256_extract_epi32);
	eval 'sub _mm256_extract_epi16 {
	    my($X, $N) = @_;
    	    eval q(( &__extension__ ({  &__m128i  &__Y =  &_mm256_extractf128_si256 (($X), ($N) >> 3);  &_mm_extract_epi16 ( &__Y, ($N) % 8); })));
	}' unless defined(&_mm256_extract_epi16);
	eval 'sub _mm256_extract_epi8 {
	    my($X, $N) = @_;
    	    eval q(( &__extension__ ({  &__m128i  &__Y =  &_mm256_extractf128_si256 (($X), ($N) >> 4);  &_mm_extract_epi8 ( &__Y, ($N) % 16); })));
	}' unless defined(&_mm256_extract_epi8);
	if(defined(&__x86_64__)) {
	    eval 'sub _mm256_extract_epi64 {
	        my($X, $N) = @_;
    		eval q(( &__extension__ ({  &__m128i  &__Y =  &_mm256_extractf128_si256 (($X), ($N) >> 1);  &_mm_extract_epi64 ( &__Y, ($N) % 2); })));
	    }' unless defined(&_mm256_extract_epi64);
	}
    }
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_zeroall ( &void) {  &__builtin_ia32_vzeroall (); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_zeroupper ( &void) {  &__builtin_ia32_vzeroupper (); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_permutevar_pd ( &__m128d  &__A,  &__m128i  &__C) { ( &__m128d)  &__builtin_ia32_vpermilvarpd (( &__v2df) &__A, ( &__v2di) &__C); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_permutevar_pd ( &__m256d  &__A,  &__m256i  &__C) { ( &__m256d)  &__builtin_ia32_vpermilvarpd256 (( &__v4df) &__A, ( &__v4di) &__C); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_permutevar_ps ( &__m128  &__A,  &__m128i  &__C) { ( &__m128)  &__builtin_ia32_vpermilvarps (( &__v4sf) &__A, ( &__v4si) &__C); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_permutevar_ps ( &__m256  &__A,  &__m256i  &__C) { ( &__m256)  &__builtin_ia32_vpermilvarps256 (( &__v8sf) &__A, ( &__v8si) &__C); });
    }' unless defined(&__attribute__);
    if(defined(&__OPTIMIZE__)) {
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_permute_pd ( &__m128d  &__X,  &const \'int\'  &__C) { ( &__m128d)  &__builtin_ia32_vpermilpd (( &__v2df) &__X,  &__C); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_permute_pd ( &__m256d  &__X,  &const \'int\'  &__C) { ( &__m256d)  &__builtin_ia32_vpermilpd256 (( &__v4df) &__X,  &__C); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_permute_ps ( &__m128  &__X,  &const \'int\'  &__C) { ( &__m128)  &__builtin_ia32_vpermilps (( &__v4sf) &__X,  &__C); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_permute_ps ( &__m256  &__X,  &const \'int\'  &__C) { ( &__m256)  &__builtin_ia32_vpermilps256 (( &__v8sf) &__X,  &__C); });
	}' unless defined(&__attribute__);
    } else {
	eval 'sub _mm_permute_pd {
	    my($X, $C) = @_;
    	    eval q((( &__m128d)  &__builtin_ia32_vpermilpd (( &__v2df)( &__m128d), ($C))));
	}' unless defined(&_mm_permute_pd);
	eval 'sub _mm256_permute_pd {
	    my($X, $C) = @_;
    	    eval q((( &__m256d)  &__builtin_ia32_vpermilpd256 (( &__v4df)( &__m256d), ($C))));
	}' unless defined(&_mm256_permute_pd);
	eval 'sub _mm_permute_ps {
	    my($X, $C) = @_;
    	    eval q((( &__m128)  &__builtin_ia32_vpermilps (( &__v4sf)( &__m128), ($C))));
	}' unless defined(&_mm_permute_ps);
	eval 'sub _mm256_permute_ps {
	    my($X, $C) = @_;
    	    eval q((( &__m256)  &__builtin_ia32_vpermilps256 (( &__v8sf)( &__m256), ($C))));
	}' unless defined(&_mm256_permute_ps);
    }
    if(defined(&__OPTIMIZE__)) {
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_permute2f128_pd ( &__m256d  &__X,  &__m256d  &__Y,  &const \'int\'  &__C) { ( &__m256d)  &__builtin_ia32_vperm2f128_pd256 (( &__v4df) &__X, ( &__v4df) &__Y,  &__C); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_permute2f128_ps ( &__m256  &__X,  &__m256  &__Y,  &const \'int\'  &__C) { ( &__m256)  &__builtin_ia32_vperm2f128_ps256 (( &__v8sf) &__X, ( &__v8sf) &__Y,  &__C); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_permute2f128_si256 ( &__m256i  &__X,  &__m256i  &__Y,  &const \'int\'  &__C) { ( &__m256i)  &__builtin_ia32_vperm2f128_si256 (( &__v8si) &__X, ( &__v8si) &__Y,  &__C); });
	}' unless defined(&__attribute__);
    } else {
	eval 'sub _mm256_permute2f128_pd {
	    my($X, $Y, $C) = @_;
    	    eval q((( &__m256d)  &__builtin_ia32_vperm2f128_pd256 (( &__v4df)( &__m256d)($X), ( &__v4df)( &__m256d), ($C))));
	}' unless defined(&_mm256_permute2f128_pd);
	eval 'sub _mm256_permute2f128_ps {
	    my($X, $Y, $C) = @_;
    	    eval q((( &__m256)  &__builtin_ia32_vperm2f128_ps256 (( &__v8sf)( &__m256)($X), ( &__v8sf)( &__m256), ($C))));
	}' unless defined(&_mm256_permute2f128_ps);
	eval 'sub _mm256_permute2f128_si256 {
	    my($X, $Y, $C) = @_;
    	    eval q((( &__m256i)  &__builtin_ia32_vperm2f128_si256 (( &__v8si)( &__m256i)($X), ( &__v8si)( &__m256i), ($C))));
	}' unless defined(&_mm256_permute2f128_si256);
    }
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_broadcast_ss (\'float\'  &const * &__X) { ( &__m128)  &__builtin_ia32_vbroadcastss ( &__X); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_broadcast_sd (\'double\'  &const * &__X) { ( &__m256d)  &__builtin_ia32_vbroadcastsd256 ( &__X); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_broadcast_ss (\'float\'  &const * &__X) { ( &__m256)  &__builtin_ia32_vbroadcastss256 ( &__X); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_broadcast_pd ( &__m128d  &const * &__X) { ( &__m256d)  &__builtin_ia32_vbroadcastf128_pd256 ( &__X); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_broadcast_ps ( &__m128  &const * &__X) { ( &__m256)  &__builtin_ia32_vbroadcastf128_ps256 ( &__X); });
    }' unless defined(&__attribute__);
    if(defined(&__OPTIMIZE__)) {
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_insertf128_pd ( &__m256d  &__X,  &__m128d  &__Y,  &const \'int\'  &__O) { ( &__m256d)  &__builtin_ia32_vinsertf128_pd256 (( &__v4df) &__X, ( &__v2df) &__Y,  &__O); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_insertf128_ps ( &__m256  &__X,  &__m128  &__Y,  &const \'int\'  &__O) { ( &__m256)  &__builtin_ia32_vinsertf128_ps256 (( &__v8sf) &__X, ( &__v4sf) &__Y,  &__O); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_insertf128_si256 ( &__m256i  &__X,  &__m128i  &__Y,  &const \'int\'  &__O) { ( &__m256i)  &__builtin_ia32_vinsertf128_si256 (( &__v8si) &__X, ( &__v4si) &__Y,  &__O); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_insert_epi32 ( &__m256i  &__X, \'int\'  &__D, \'int\'  &const  &__N) {  &__m128i  &__Y =  &_mm256_extractf128_si256 ( &__X,  &__N >> 2);  &__Y =  &_mm_insert_epi32 ( &__Y,  &__D,  &__N % 4);  &_mm256_insertf128_si256 ( &__X,  &__Y,  &__N >> 2); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_insert_epi16 ( &__m256i  &__X, \'int\'  &__D, \'int\'  &const  &__N) {  &__m128i  &__Y =  &_mm256_extractf128_si256 ( &__X,  &__N >> 3);  &__Y =  &_mm_insert_epi16 ( &__Y,  &__D,  &__N % 8);  &_mm256_insertf128_si256 ( &__X,  &__Y,  &__N >> 3); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_insert_epi8 ( &__m256i  &__X, \'int\'  &__D, \'int\'  &const  &__N) {  &__m128i  &__Y =  &_mm256_extractf128_si256 ( &__X,  &__N >> 4);  &__Y =  &_mm_insert_epi8 ( &__Y,  &__D,  &__N % 16);  &_mm256_insertf128_si256 ( &__X,  &__Y,  &__N >> 4); });
	}' unless defined(&__attribute__);
	if(defined(&__x86_64__)) {
	    eval 'sub __attribute__ () {
	        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_insert_epi64 ( &__m256i  &__X, my $__D, \'int\'  &const  &__N) {  &__m128i  &__Y =  &_mm256_extractf128_si256 ( &__X,  &__N >> 1);  &__Y =  &_mm_insert_epi64 ( &__Y,  $__D,  &__N % 2);  &_mm256_insertf128_si256 ( &__X,  &__Y,  &__N >> 1); });
	    }' unless defined(&__attribute__);
	}
    } else {
	eval 'sub _mm256_insertf128_pd {
	    my($X, $Y, $O) = @_;
    	    eval q((( &__m256d)  &__builtin_ia32_vinsertf128_pd256 (( &__v4df)( &__m256d)($X), ( &__v2df)( &__m128d), ($O))));
	}' unless defined(&_mm256_insertf128_pd);
	eval 'sub _mm256_insertf128_ps {
	    my($X, $Y, $O) = @_;
    	    eval q((( &__m256)  &__builtin_ia32_vinsertf128_ps256 (( &__v8sf)( &__m256)($X), ( &__v4sf)( &__m128), ($O))));
	}' unless defined(&_mm256_insertf128_ps);
	eval 'sub _mm256_insertf128_si256 {
	    my($X, $Y, $O) = @_;
    	    eval q((( &__m256i)  &__builtin_ia32_vinsertf128_si256 (( &__v8si)( &__m256i)($X), ( &__v4si)( &__m128i), ($O))));
	}' unless defined(&_mm256_insertf128_si256);
	eval 'sub _mm256_insert_epi32 {
	    my($X, $D, $N) = @_;
    	    eval q(( &__extension__ ({  &__m128i  &__Y =  &_mm256_extractf128_si256 (($X), ($N) >> 2);  &__Y =  &_mm_insert_epi32 ( &__Y, ($D), ($N) % 4);  &_mm256_insertf128_si256 (($X),  &__Y, ($N) >> 2); })));
	}' unless defined(&_mm256_insert_epi32);
	eval 'sub _mm256_insert_epi16 {
	    my($X, $D, $N) = @_;
    	    eval q(( &__extension__ ({  &__m128i  &__Y =  &_mm256_extractf128_si256 (($X), ($N) >> 3);  &__Y =  &_mm_insert_epi16 ( &__Y, ($D), ($N) % 8);  &_mm256_insertf128_si256 (($X),  &__Y, ($N) >> 3); })));
	}' unless defined(&_mm256_insert_epi16);
	eval 'sub _mm256_insert_epi8 {
	    my($X, $D, $N) = @_;
    	    eval q(( &__extension__ ({  &__m128i  &__Y =  &_mm256_extractf128_si256 (($X), ($N) >> 4);  &__Y =  &_mm_insert_epi8 ( &__Y, ($D), ($N) % 16);  &_mm256_insertf128_si256 (($X),  &__Y, ($N) >> 4); })));
	}' unless defined(&_mm256_insert_epi8);
	if(defined(&__x86_64__)) {
	    eval 'sub _mm256_insert_epi64 {
	        my($X, $D, $N) = @_;
    		eval q(( &__extension__ ({  &__m128i  &__Y =  &_mm256_extractf128_si256 (($X), ($N) >> 1);  &__Y =  &_mm_insert_epi64 ( &__Y, ($D), ($N) % 2);  &_mm256_insertf128_si256 (($X),  &__Y, ($N) >> 1); })));
	    }' unless defined(&_mm256_insert_epi64);
	}
    }
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_load_pd (\'double\'  &const * &__P) { *( &__m256d *) &__P; });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_store_pd (\'double\' * &__P,  &__m256d  &__A) { *( &__m256d *) &__P =  &__A; });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_load_ps (\'float\'  &const * &__P) { *( &__m256 *) &__P; });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_store_ps (\'float\' * &__P,  &__m256  &__A) { *( &__m256 *) &__P =  &__A; });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_loadu_pd (\'double\'  &const * &__P) { *( &__m256d_u *) &__P; });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_storeu_pd (\'double\' * &__P,  &__m256d  &__A) { *( &__m256d_u *) &__P =  &__A; });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_loadu_ps (\'float\'  &const * &__P) { *( &__m256_u *) &__P; });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_storeu_ps (\'float\' * &__P,  &__m256  &__A) { *( &__m256_u *) &__P =  &__A; });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_load_si256 ( &__m256i  &const * &__P) { * &__P; });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_store_si256 ( &__m256i * &__P,  &__m256i  &__A) { * &__P =  &__A; });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_loadu_si256 ( &__m256i_u  &const * &__P) { * &__P; });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_storeu_si256 ( &__m256i_u * &__P,  &__m256i  &__A) { * &__P =  &__A; });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_maskload_pd (\'double\'  &const * &__P,  &__m128i  &__M) { ( &__m128d)  &__builtin_ia32_maskloadpd (( &const  &__v2df *) &__P, ( &__v2di) &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_maskstore_pd (\'double\' * &__P,  &__m128i  &__M,  &__m128d  &__A) {  &__builtin_ia32_maskstorepd (( &__v2df *) &__P, ( &__v2di) &__M, ( &__v2df) &__A); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_maskload_pd (\'double\'  &const * &__P,  &__m256i  &__M) { ( &__m256d)  &__builtin_ia32_maskloadpd256 (( &const  &__v4df *) &__P, ( &__v4di) &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_maskstore_pd (\'double\' * &__P,  &__m256i  &__M,  &__m256d  &__A) {  &__builtin_ia32_maskstorepd256 (( &__v4df *) &__P, ( &__v4di) &__M, ( &__v4df) &__A); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_maskload_ps (\'float\'  &const * &__P,  &__m128i  &__M) { ( &__m128)  &__builtin_ia32_maskloadps (( &const  &__v4sf *) &__P, ( &__v4si) &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_maskstore_ps (\'float\' * &__P,  &__m128i  &__M,  &__m128  &__A) {  &__builtin_ia32_maskstoreps (( &__v4sf *) &__P, ( &__v4si) &__M, ( &__v4sf) &__A); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_maskload_ps (\'float\'  &const * &__P,  &__m256i  &__M) { ( &__m256)  &__builtin_ia32_maskloadps256 (( &const  &__v8sf *) &__P, ( &__v8si) &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_maskstore_ps (\'float\' * &__P,  &__m256i  &__M,  &__m256  &__A) {  &__builtin_ia32_maskstoreps256 (( &__v8sf *) &__P, ( &__v8si) &__M, ( &__v8sf) &__A); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_movehdup_ps ( &__m256  &__X) { ( &__m256)  &__builtin_ia32_movshdup256 (( &__v8sf) &__X); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_moveldup_ps ( &__m256  &__X) { ( &__m256)  &__builtin_ia32_movsldup256 (( &__v8sf) &__X); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_movedup_pd ( &__m256d  &__X) { ( &__m256d)  &__builtin_ia32_movddup256 (( &__v4df) &__X); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_lddqu_si256 ( &__m256i  &const * &__P) { ( &__m256i)  &__builtin_ia32_lddqu256 ((\'char\'  &const *) &__P); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_stream_si256 ( &__m256i * &__A,  &__m256i  &__B) {  &__builtin_ia32_movntdq256 (( &__v4di *) &__A, ( &__v4di) &__B); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_stream_pd (\'double\' * &__A,  &__m256d  &__B) {  &__builtin_ia32_movntpd256 ( &__A, ( &__v4df) &__B); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_stream_ps (\'float\' * &__P,  &__m256  &__A) {  &__builtin_ia32_movntps256 ( &__P, ( &__v8sf) &__A); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_rcp_ps ( &__m256  &__A) { ( &__m256)  &__builtin_ia32_rcpps256 (( &__v8sf) &__A); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_rsqrt_ps ( &__m256  &__A) { ( &__m256)  &__builtin_ia32_rsqrtps256 (( &__v8sf) &__A); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_sqrt_pd ( &__m256d  &__A) { ( &__m256d)  &__builtin_ia32_sqrtpd256 (( &__v4df) &__A); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_sqrt_ps ( &__m256  &__A) { ( &__m256)  &__builtin_ia32_sqrtps256 (( &__v8sf) &__A); });
    }' unless defined(&__attribute__);
    if(defined(&__OPTIMIZE__)) {
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_round_pd ( &__m256d  &__V,  &const \'int\'  &__M) { ( &__m256d)  &__builtin_ia32_roundpd256 (( &__v4df) &__V,  &__M); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_round_ps ( &__m256  &__V,  &const \'int\'  &__M) { ( &__m256)  &__builtin_ia32_roundps256 (( &__v8sf) &__V,  &__M); });
	}' unless defined(&__attribute__);
    } else {
	eval 'sub _mm256_round_pd {
	    my($V, $M) = @_;
    	    eval q((( &__m256d)  &__builtin_ia32_roundpd256 (( &__v4df)( &__m256d), ($M))));
	}' unless defined(&_mm256_round_pd);
	eval 'sub _mm256_round_ps {
	    my($V, $M) = @_;
    	    eval q((( &__m256)  &__builtin_ia32_roundps256 (( &__v8sf)( &__m256), ($M))));
	}' unless defined(&_mm256_round_ps);
    }
    eval 'sub _mm256_ceil_pd {
        my($V) = @_;
	    eval q( &_mm256_round_pd (($V),  &_MM_FROUND_CEIL));
    }' unless defined(&_mm256_ceil_pd);
    eval 'sub _mm256_floor_pd {
        my($V) = @_;
	    eval q( &_mm256_round_pd (($V),  &_MM_FROUND_FLOOR));
    }' unless defined(&_mm256_floor_pd);
    eval 'sub _mm256_ceil_ps {
        my($V) = @_;
	    eval q( &_mm256_round_ps (($V),  &_MM_FROUND_CEIL));
    }' unless defined(&_mm256_ceil_ps);
    eval 'sub _mm256_floor_ps {
        my($V) = @_;
	    eval q( &_mm256_round_ps (($V),  &_MM_FROUND_FLOOR));
    }' unless defined(&_mm256_floor_ps);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_unpackhi_pd ( &__m256d  &__A,  &__m256d  &__B) { ( &__m256d)  &__builtin_ia32_unpckhpd256 (( &__v4df) &__A, ( &__v4df) &__B); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_unpacklo_pd ( &__m256d  &__A,  &__m256d  &__B) { ( &__m256d)  &__builtin_ia32_unpcklpd256 (( &__v4df) &__A, ( &__v4df) &__B); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_unpackhi_ps ( &__m256  &__A,  &__m256  &__B) { ( &__m256)  &__builtin_ia32_unpckhps256 (( &__v8sf) &__A, ( &__v8sf) &__B); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_unpacklo_ps ( &__m256  &__A,  &__m256  &__B) { ( &__m256)  &__builtin_ia32_unpcklps256 (( &__v8sf) &__A, ( &__v8sf) &__B); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_testz_pd ( &__m128d  &__M,  &__m128d  &__V) {  &__builtin_ia32_vtestzpd (( &__v2df) &__M, ( &__v2df) &__V); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_testc_pd ( &__m128d  &__M,  &__m128d  &__V) {  &__builtin_ia32_vtestcpd (( &__v2df) &__M, ( &__v2df) &__V); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_testnzc_pd ( &__m128d  &__M,  &__m128d  &__V) {  &__builtin_ia32_vtestnzcpd (( &__v2df) &__M, ( &__v2df) &__V); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_testz_ps ( &__m128  &__M,  &__m128  &__V) {  &__builtin_ia32_vtestzps (( &__v4sf) &__M, ( &__v4sf) &__V); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_testc_ps ( &__m128  &__M,  &__m128  &__V) {  &__builtin_ia32_vtestcps (( &__v4sf) &__M, ( &__v4sf) &__V); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_testnzc_ps ( &__m128  &__M,  &__m128  &__V) {  &__builtin_ia32_vtestnzcps (( &__v4sf) &__M, ( &__v4sf) &__V); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_testz_pd ( &__m256d  &__M,  &__m256d  &__V) {  &__builtin_ia32_vtestzpd256 (( &__v4df) &__M, ( &__v4df) &__V); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_testc_pd ( &__m256d  &__M,  &__m256d  &__V) {  &__builtin_ia32_vtestcpd256 (( &__v4df) &__M, ( &__v4df) &__V); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_testnzc_pd ( &__m256d  &__M,  &__m256d  &__V) {  &__builtin_ia32_vtestnzcpd256 (( &__v4df) &__M, ( &__v4df) &__V); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_testz_ps ( &__m256  &__M,  &__m256  &__V) {  &__builtin_ia32_vtestzps256 (( &__v8sf) &__M, ( &__v8sf) &__V); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_testc_ps ( &__m256  &__M,  &__m256  &__V) {  &__builtin_ia32_vtestcps256 (( &__v8sf) &__M, ( &__v8sf) &__V); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_testnzc_ps ( &__m256  &__M,  &__m256  &__V) {  &__builtin_ia32_vtestnzcps256 (( &__v8sf) &__M, ( &__v8sf) &__V); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_testz_si256 ( &__m256i  &__M,  &__m256i  &__V) {  &__builtin_ia32_ptestz256 (( &__v4di) &__M, ( &__v4di) &__V); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_testc_si256 ( &__m256i  &__M,  &__m256i  &__V) {  &__builtin_ia32_ptestc256 (( &__v4di) &__M, ( &__v4di) &__V); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_testnzc_si256 ( &__m256i  &__M,  &__m256i  &__V) {  &__builtin_ia32_ptestnzc256 (( &__v4di) &__M, ( &__v4di) &__V); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_movemask_pd ( &__m256d  &__A) {  &__builtin_ia32_movmskpd256 (( &__v4df) &__A); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_movemask_ps ( &__m256  &__A) {  &__builtin_ia32_movmskps256 (( &__v8sf) &__A); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_undefined_pd ( &void) {  &__m256d  &__Y =  &__Y;  &__Y; });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_undefined_ps ( &void) {  &__m256  &__Y =  &__Y;  &__Y; });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_undefined_si256 ( &void) {  &__m256i  &__Y =  &__Y;  &__Y; });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_setzero_pd ( &void) { ( &__m256d){ 0.0, 0.0, 0.0, 0.0}; });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_setzero_ps ( &void) { ( &__m256){ 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}; });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_setzero_si256 ( &void) { ( &__m256i)( &__v4di){ 0, 0, 0, 0}; });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_set_epi16 (my $__q15, my $__q14, my $__q13, my $__q12, my $__q11, my $__q10, my $__q09, my $__q08, my $__q07, my $__q06, my $__q05, my $__q04, my $__q03, my $__q02, my $__q01, my $__q00) { ( &__m256i)( &__v16hi){  $__q00,  $__q01,  $__q02,  $__q03,  $__q04,  $__q05,  $__q06,  $__q07,  $__q08,  $__q09,  $__q10,  $__q11,  $__q12,  $__q13,  $__q14,  $__q15 }; });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_set_epi8 (\'char\'  &__q31, \'char\'  &__q30, \'char\'  &__q29, \'char\'  &__q28, \'char\'  &__q27, \'char\'  &__q26, \'char\'  &__q25, \'char\'  &__q24, \'char\'  &__q23, \'char\'  &__q22, \'char\'  &__q21, \'char\'  &__q20, \'char\'  &__q19, \'char\'  &__q18, \'char\'  &__q17, \'char\'  &__q16, \'char\'  &__q15, \'char\'  &__q14, \'char\'  &__q13, \'char\'  &__q12, \'char\'  &__q11, \'char\'  &__q10, \'char\'  &__q09, \'char\'  &__q08, \'char\'  &__q07, \'char\'  &__q06, \'char\'  &__q05, \'char\'  &__q04, \'char\'  &__q03, \'char\'  &__q02, \'char\'  &__q01, \'char\'  &__q00) { ( &__m256i)( &__v32qi){  &__q00,  &__q01,  &__q02,  &__q03,  &__q04,  &__q05,  &__q06,  &__q07,  &__q08,  &__q09,  &__q10,  &__q11,  &__q12,  &__q13,  &__q14,  &__q15,  &__q16,  &__q17,  &__q18,  &__q19,  &__q20,  &__q21,  &__q22,  &__q23,  &__q24,  &__q25,  &__q26,  &__q27,  &__q28,  &__q29,  &__q30,  &__q31 }; });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_set_epi64x (my $__A, my $__B, my $__C, my $__D) { ( &__m256i)( &__v4di){  $__D,  $__C,  $__B,  $__A }; });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_set1_epi16  {  &_mm256_set_epi16 ( &__A,  &__A,  &__A,  &__A,  &__A,  &__A,  &__A,  &__A,  &__A,  &__A,  &__A,  &__A,  &__A,  &__A,  &__A,  &__A); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_set1_epi8 (\'char\'  &__A) {  &_mm256_set_epi8 ( &__A,  &__A,  &__A,  &__A,  &__A,  &__A,  &__A,  &__A,  &__A,  &__A,  &__A,  &__A,  &__A,  &__A,  &__A,  &__A,  &__A,  &__A,  &__A,  &__A,  &__A,  &__A,  &__A,  &__A,  &__A,  &__A,  &__A,  &__A,  &__A,  &__A,  &__A,  &__A); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_set1_epi64x  { ( &__m256i)( &__v4di){  &__A,  &__A,  &__A,  &__A }; });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_setr_ps (\'float\'  &__A, \'float\'  &__B, \'float\'  &__C, \'float\'  &__D, \'float\'  &__E, \'float\'  &__F, \'float\'  &__G, \'float\'  &__H) {  &_mm256_set_ps ( &__H,  &__G,  &__F,  &__E,  &__D,  &__C,  &__B,  &__A); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_setr_epi32 (\'int\'  &__A, \'int\'  &__B, \'int\'  &__C, \'int\'  &__D, \'int\'  &__E, \'int\'  &__F, \'int\'  &__G, \'int\'  &__H) {  &_mm256_set_epi32 ( &__H,  &__G,  &__F,  &__E,  &__D,  &__C,  &__B,  &__A); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_setr_epi16 (my $__q15, my $__q14, my $__q13, my $__q12, my $__q11, my $__q10, my $__q09, my $__q08, my $__q07, my $__q06, my $__q05, my $__q04, my $__q03, my $__q02, my $__q01, my $__q00) {  &_mm256_set_epi16 ( $__q00,  $__q01,  $__q02,  $__q03,  $__q04,  $__q05,  $__q06,  $__q07,  $__q08,  $__q09,  $__q10,  $__q11,  $__q12,  $__q13,  $__q14,  $__q15); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_setr_epi8 (\'char\'  &__q31, \'char\'  &__q30, \'char\'  &__q29, \'char\'  &__q28, \'char\'  &__q27, \'char\'  &__q26, \'char\'  &__q25, \'char\'  &__q24, \'char\'  &__q23, \'char\'  &__q22, \'char\'  &__q21, \'char\'  &__q20, \'char\'  &__q19, \'char\'  &__q18, \'char\'  &__q17, \'char\'  &__q16, \'char\'  &__q15, \'char\'  &__q14, \'char\'  &__q13, \'char\'  &__q12, \'char\'  &__q11, \'char\'  &__q10, \'char\'  &__q09, \'char\'  &__q08, \'char\'  &__q07, \'char\'  &__q06, \'char\'  &__q05, \'char\'  &__q04, \'char\'  &__q03, \'char\'  &__q02, \'char\'  &__q01, \'char\'  &__q00) {  &_mm256_set_epi8 ( &__q00,  &__q01,  &__q02,  &__q03,  &__q04,  &__q05,  &__q06,  &__q07,  &__q08,  &__q09,  &__q10,  &__q11,  &__q12,  &__q13,  &__q14,  &__q15,  &__q16,  &__q17,  &__q18,  &__q19,  &__q20,  &__q21,  &__q22,  &__q23,  &__q24,  &__q25,  &__q26,  &__q27,  &__q28,  &__q29,  &__q30,  &__q31); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_setr_epi64x (my $__A, my $__B, my $__C, my $__D) {  &_mm256_set_epi64x ( $__D,  $__C,  $__B,  $__A); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_castpd_si256 ( &__m256d  &__A) { ( &__m256i)  &__A; });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_castps_pd ( &__m256  &__A) { ( &__m256d)  &__A; });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_castps_si256( &__m256  &__A) { ( &__m256i)  &__A; });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_castsi256_ps ( &__m256i  &__A) { ( &__m256)  &__A; });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_castsi256_pd ( &__m256i  &__A) { ( &__m256d)  &__A; });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_castpd256_pd128 ( &__m256d  &__A) { ( &__m128d)  &__builtin_ia32_pd_pd256 (( &__v4df) &__A); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_castps256_ps128 ( &__m256  &__A) { ( &__m128)  &__builtin_ia32_ps_ps256 (( &__v8sf) &__A); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_castsi256_si128 ( &__m256i  &__A) { ( &__m128i)  &__builtin_ia32_si_si256 (( &__v8si) &__A); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_castps128_ps256 ( &__m128  &__A) { ( &__m256)  &__builtin_ia32_ps256_ps (( &__v4sf) &__A); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_castsi128_si256 ( &__m128i  &__A) { ( &__m256i)  &__builtin_ia32_si256_si (( &__v4si) &__A); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_zextps128_ps256 ( &__m128  &__A) {  &_mm256_insertf128_ps ( &_mm256_setzero_ps (),  &__A, 0); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_zextsi128_si256 ( &__m128i  &__A) {  &_mm256_insertf128_si256 ( &_mm256_setzero_si256 (),  &__A, 0); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_set_m128 (  &__m128  &__H,  &__m128  &__L) {  &_mm256_insertf128_ps ( &_mm256_castps128_ps256 ( &__L),  &__H, 1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_set_m128d ( &__m128d  &__H,  &__m128d  &__L) {  &_mm256_insertf128_pd ( &_mm256_castpd128_pd256 ( &__L),  &__H, 1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_set_m128i ( &__m128i  &__H,  &__m128i  &__L) {  &_mm256_insertf128_si256 ( &_mm256_castsi128_si256 ( &__L),  &__H, 1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_setr_m128 ( &__m128  &__L,  &__m128  &__H) {  &_mm256_set_m128 ( &__H,  &__L); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_setr_m128d ( &__m128d  &__L,  &__m128d  &__H) {  &_mm256_set_m128d ( &__H,  &__L); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_setr_m128i ( &__m128i  &__L,  &__m128i  &__H) {  &_mm256_set_m128i ( &__H,  &__L); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_loadu2_m128 (\'float\'  &const * &__PH, \'float\'  &const * &__PL) {  &_mm256_insertf128_ps ( &_mm256_castps128_ps256 ( &_mm_loadu_ps ( &__PL)),  &_mm_loadu_ps ( &__PH), 1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_storeu2_m128 (\'float\' * &__PH, \'float\' * &__PL,  &__m256  &__A) {  &_mm_storeu_ps ( &__PL,  &_mm256_castps256_ps128 ( &__A));  &_mm_storeu_ps ( &__PH,  &_mm256_extractf128_ps ( &__A, 1)); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_loadu2_m128d (\'double\'  &const * &__PH, \'double\'  &const * &__PL) {  &_mm256_insertf128_pd ( &_mm256_castpd128_pd256 ( &_mm_loadu_pd ( &__PL)),  &_mm_loadu_pd ( &__PH), 1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_storeu2_m128d (\'double\' * &__PH, \'double\' * &__PL,  &__m256d  &__A) {  &_mm_storeu_pd ( &__PL,  &_mm256_castpd256_pd128 ( &__A));  &_mm_storeu_pd ( &__PH,  &_mm256_extractf128_pd ( &__A, 1)); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_loadu2_m128i ( &__m128i_u  &const * &__PH,  &__m128i_u  &const * &__PL) {  &_mm256_insertf128_si256 ( &_mm256_castsi128_si256 ( &_mm_loadu_si128 ( &__PL)),  &_mm_loadu_si128 ( &__PH), 1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_storeu2_m128i ( &__m128i_u * &__PH,  &__m128i_u * &__PL,  &__m256i  &__A) {  &_mm_storeu_si128 ( &__PL,  &_mm256_castsi256_si128 ( &__A));  &_mm_storeu_si128 ( &__PH,  &_mm256_extractf128_si256 ( &__A, 1)); });
    }' unless defined(&__attribute__);
    if(defined(&__DISABLE_AVX__)) {
	undef(&__DISABLE_AVX__) if defined(&__DISABLE_AVX__);
    }
}
1;
