require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_IMMINTRIN_H_INCLUDED)) {
    eval 'sub _IMMINTRIN_H_INCLUDED () {1;}' unless defined(&_IMMINTRIN_H_INCLUDED);
    require 'mmintrin.ph';
    require 'xmmintrin.ph';
    require 'emmintrin.ph';
    require 'pmmintrin.ph';
    require 'tmmintrin.ph';
    require 'smmintrin.ph';
    require 'wmmintrin.ph';
    require 'fxsrintrin.ph';
    require 'xsaveintrin.ph';
    require 'xsaveoptintrin.ph';
    require 'xsavesintrin.ph';
    require 'xsavecintrin.ph';
    require 'avxintrin.ph';
    require 'avx2intrin.ph';
    require 'avx512fintrin.ph';
    require 'avx512erintrin.ph';
    require 'avx512pfintrin.ph';
    require 'avx512cdintrin.ph';
    require 'avx512vlintrin.ph';
    require 'avx512bwintrin.ph';
    require 'avx512dqintrin.ph';
    require 'avx512vlbwintrin.ph';
    require 'avx512vldqintrin.ph';
    require 'avx512ifmaintrin.ph';
    require 'avx512ifmavlintrin.ph';
    require 'avx512vbmiintrin.ph';
    require 'avx512vbmivlintrin.ph';
    require 'avx5124fmapsintrin.ph';
    require 'avx5124vnniwintrin.ph';
    require 'avx512vpopcntdqintrin.ph';
    require 'avx512vbmi2intrin.ph';
    require 'avx512vbmi2vlintrin.ph';
    require 'avx512vnniintrin.ph';
    require 'avx512vnnivlintrin.ph';
    require 'avx512vpopcntdqvlintrin.ph';
    require 'avx512bitalgintrin.ph';
    require 'avx512vp2intersectintrin.ph';
    require 'avx512vp2intersectvlintrin.ph';
    require 'shaintrin.ph';
    require 'lzcntintrin.ph';
    require 'bmiintrin.ph';
    require 'bmi2intrin.ph';
    require 'fmaintrin.ph';
    require 'f16cintrin.ph';
    require 'rtmintrin.ph';
    require 'xtestintrin.ph';
    require 'cetintrin.ph';
    require 'gfniintrin.ph';
    require 'vaesintrin.ph';
    require 'vpclmulqdqintrin.ph';
    require 'movdirintrin.ph';
    require 'sgxintrin.ph';
    require 'pconfigintrin.ph';
    require 'waitpkgintrin.ph';
    require 'cldemoteintrin.ph';
    require 'avx512bf16vlintrin.ph';
    require 'avx512bf16intrin.ph';
    require 'enqcmdintrin.ph';
    require 'rdseedintrin.ph';
    require 'prfchwintrin.ph';
    require 'adxintrin.ph';
    require 'clwbintrin.ph';
    require 'clflushoptintrin.ph';
    require 'wbnoinvdintrin.ph';
    require 'pkuintrin.ph';
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_wbinvd ( &void) {  &__builtin_ia32_wbinvd (); });
    }' unless defined(&__attribute__);
    unless(defined(&__RDRND__)) {
	eval 'sub __DISABLE_RDRND__ () {1;}' unless defined(&__DISABLE_RDRND__);
    }
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_rdrand16_step (my $short * &__P) {  &__builtin_ia32_rdrand16_step ( &__P); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_rdrand32_step (my $int * &__P) {  &__builtin_ia32_rdrand32_step ( &__P); });
    }' unless defined(&__attribute__);
    if(defined(&__DISABLE_RDRND__)) {
	undef(&__DISABLE_RDRND__) if defined(&__DISABLE_RDRND__);
    }
    unless(defined(&__RDPID__)) {
	eval 'sub __DISABLE_RDPID__ () {1;}' unless defined(&__DISABLE_RDPID__);
    }
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_rdpid_u32 ( &void) {  &__builtin_ia32_rdpid (); });
    }' unless defined(&__attribute__);
    if(defined(&__DISABLE_RDPID__)) {
	undef(&__DISABLE_RDPID__) if defined(&__DISABLE_RDPID__);
    }
    if(defined(&__x86_64__)) {
	unless(defined(&__FSGSBASE__)) {
	    eval 'sub __DISABLE_FSGSBASE__ () {1;}' unless defined(&__DISABLE_FSGSBASE__);
	}
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_readfsbase_u32 ( &void) {  &__builtin_ia32_rdfsbase32 (); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_readfsbase_u64 ( &void) {  &__builtin_ia32_rdfsbase64 (); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_readgsbase_u32 ( &void) {  &__builtin_ia32_rdgsbase32 (); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_readgsbase_u64 ( &void) {  &__builtin_ia32_rdgsbase64 (); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_writefsbase_u32  {  &__builtin_ia32_wrfsbase32 ( &__B); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_writefsbase_u64  {  &__builtin_ia32_wrfsbase64 ( &__B); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_writegsbase_u32  {  &__builtin_ia32_wrgsbase32 ( &__B); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_writegsbase_u64  {  &__builtin_ia32_wrgsbase64 ( &__B); });
	}' unless defined(&__attribute__);
	if(defined(&__DISABLE_FSGSBASE__)) {
	    undef(&__DISABLE_FSGSBASE__) if defined(&__DISABLE_FSGSBASE__);
	}
	unless(defined(&__RDRND__)) {
	    eval 'sub __DISABLE_RDRND__ () {1;}' unless defined(&__DISABLE_RDRND__);
	}
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_rdrand64_step (my $long * &__P) {  &__builtin_ia32_rdrand64_step ( &__P); });
	}' unless defined(&__attribute__);
	if(defined(&__DISABLE_RDRND__)) {
	    undef(&__DISABLE_RDRND__) if defined(&__DISABLE_RDRND__);
	}
    }
    unless(defined(&__PTWRITE__)) {
	eval 'sub __DISABLE_PTWRITE__ () {1;}' unless defined(&__DISABLE_PTWRITE__);
    }
    if(defined(&__x86_64__)) {
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_ptwrite64  {  &__builtin_ia32_ptwrite64 ( &__B); });
	}' unless defined(&__attribute__);
    }
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_ptwrite32  {  &__builtin_ia32_ptwrite32 ( &__B); });
    }' unless defined(&__attribute__);
    if(defined(&__DISABLE_PTWRITE__)) {
	undef(&__DISABLE_PTWRITE__) if defined(&__DISABLE_PTWRITE__);
    }
}
1;
