require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_MMINTRIN_H_INCLUDED)) {
    eval 'sub _MMINTRIN_H_INCLUDED () {1;}' unless defined(&_MMINTRIN_H_INCLUDED);
    if(defined (&__x86_64__)  && !defined (&__SSE__) || !defined (&__MMX__)) {
	if(defined(&__MMX_WITH_SSE__)) {
	}
 elsif(defined (&__x86_64__)) {
	} else {
	}
	eval 'sub __DISABLE_MMX__ () {1;}' unless defined(&__DISABLE_MMX__);
    }
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_m_empty ( &void) {  &_mm_empty (); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_m_from_int (\'int\'  &__i) {  &_mm_cvtsi32_si64 ( &__i); });
    }' unless defined(&__attribute__);
    if(defined(&__x86_64__)) {
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_cvtsi64_m64  { ( &__m64)  &__i; });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_set_pi64x  { ( &__m64)  &__i; });
	}' unless defined(&__attribute__);
    }
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_m_to_int ( &__m64  &__i) {  &_mm_cvtsi64_si32 ( &__i); });
    }' unless defined(&__attribute__);
    if(defined(&__x86_64__)) {
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_cvtm64_si64 {  &__i; });
	}' unless defined(&__attribute__);
    }
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_m_packsswb ( &__m64  &__m1,  &__m64  &__m2) {  &_mm_packs_pi16 ( &__m1,  &__m2); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_m_packssdw ( &__m64  &__m1,  &__m64  &__m2) {  &_mm_packs_pi32 ( &__m1,  &__m2); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_m_packuswb ( &__m64  &__m1,  &__m64  &__m2) {  &_mm_packs_pu16 ( &__m1,  &__m2); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_m_punpckhbw ( &__m64  &__m1,  &__m64  &__m2) {  &_mm_unpackhi_pi8 ( &__m1,  &__m2); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_m_punpckhwd ( &__m64  &__m1,  &__m64  &__m2) {  &_mm_unpackhi_pi16 ( &__m1,  &__m2); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_m_punpckhdq ( &__m64  &__m1,  &__m64  &__m2) {  &_mm_unpackhi_pi32 ( &__m1,  &__m2); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_m_punpcklbw ( &__m64  &__m1,  &__m64  &__m2) {  &_mm_unpacklo_pi8 ( &__m1,  &__m2); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_m_punpcklwd ( &__m64  &__m1,  &__m64  &__m2) {  &_mm_unpacklo_pi16 ( &__m1,  &__m2); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_m_punpckldq ( &__m64  &__m1,  &__m64  &__m2) {  &_mm_unpacklo_pi32 ( &__m1,  &__m2); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_m_paddb ( &__m64  &__m1,  &__m64  &__m2) {  &_mm_add_pi8 ( &__m1,  &__m2); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_m_paddw ( &__m64  &__m1,  &__m64  &__m2) {  &_mm_add_pi16 ( &__m1,  &__m2); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_m_paddd ( &__m64  &__m1,  &__m64  &__m2) {  &_mm_add_pi32 ( &__m1,  &__m2); });
    }' unless defined(&__attribute__);
    unless(defined(&__SSE2__)) {
	if(defined(&__MMX_WITH_SSE__)) {
	} else {
	}
	eval 'sub __DISABLE_SSE2__ () {1;}' unless defined(&__DISABLE_SSE2__);
    }
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_add_si64 ( &__m64  &__m1,  &__m64  &__m2) { ( &__m64)  &__builtin_ia32_paddq (( &__v1di) &__m1, ( &__v1di) &__m2); });
    }' unless defined(&__attribute__);
    if(defined(&__DISABLE_SSE2__)) {
	undef(&__DISABLE_SSE2__) if defined(&__DISABLE_SSE2__);
    }
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_m_paddsb ( &__m64  &__m1,  &__m64  &__m2) {  &_mm_adds_pi8 ( &__m1,  &__m2); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_m_paddsw ( &__m64  &__m1,  &__m64  &__m2) {  &_mm_adds_pi16 ( &__m1,  &__m2); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_m_paddusb ( &__m64  &__m1,  &__m64  &__m2) {  &_mm_adds_pu8 ( &__m1,  &__m2); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_m_paddusw ( &__m64  &__m1,  &__m64  &__m2) {  &_mm_adds_pu16 ( &__m1,  &__m2); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_m_psubb ( &__m64  &__m1,  &__m64  &__m2) {  &_mm_sub_pi8 ( &__m1,  &__m2); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_m_psubw ( &__m64  &__m1,  &__m64  &__m2) {  &_mm_sub_pi16 ( &__m1,  &__m2); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_m_psubd ( &__m64  &__m1,  &__m64  &__m2) {  &_mm_sub_pi32 ( &__m1,  &__m2); });
    }' unless defined(&__attribute__);
    unless(defined(&__SSE2__)) {
	if(defined(&__MMX_WITH_SSE__)) {
	} else {
	}
	eval 'sub __DISABLE_SSE2__ () {1;}' unless defined(&__DISABLE_SSE2__);
    }
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_sub_si64 ( &__m64  &__m1,  &__m64  &__m2) { ( &__m64)  &__builtin_ia32_psubq (( &__v1di) &__m1, ( &__v1di) &__m2); });
    }' unless defined(&__attribute__);
    if(defined(&__DISABLE_SSE2__)) {
	undef(&__DISABLE_SSE2__) if defined(&__DISABLE_SSE2__);
    }
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_m_psubsb ( &__m64  &__m1,  &__m64  &__m2) {  &_mm_subs_pi8 ( &__m1,  &__m2); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_m_psubsw ( &__m64  &__m1,  &__m64  &__m2) {  &_mm_subs_pi16 ( &__m1,  &__m2); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_m_psubusb ( &__m64  &__m1,  &__m64  &__m2) {  &_mm_subs_pu8 ( &__m1,  &__m2); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_m_psubusw ( &__m64  &__m1,  &__m64  &__m2) {  &_mm_subs_pu16 ( &__m1,  &__m2); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_m_pmaddwd ( &__m64  &__m1,  &__m64  &__m2) {  &_mm_madd_pi16 ( &__m1,  &__m2); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_m_pmulhw ( &__m64  &__m1,  &__m64  &__m2) {  &_mm_mulhi_pi16 ( &__m1,  &__m2); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_m_pmullw ( &__m64  &__m1,  &__m64  &__m2) {  &_mm_mullo_pi16 ( &__m1,  &__m2); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_m_psllw ( &__m64  &__m,  &__m64  &__count) {  &_mm_sll_pi16 ( &__m,  &__count); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_slli_pi16 ( &__m64  &__m, \'int\'  &__count) { ( &__m64)  &__builtin_ia32_psllwi (( &__v4hi) &__m,  &__count); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_m_psllwi ( &__m64  &__m, \'int\'  &__count) {  &_mm_slli_pi16 ( &__m,  &__count); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_m_pslld ( &__m64  &__m,  &__m64  &__count) {  &_mm_sll_pi32 ( &__m,  &__count); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_slli_pi32 ( &__m64  &__m, \'int\'  &__count) { ( &__m64)  &__builtin_ia32_pslldi (( &__v2si) &__m,  &__count); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_m_pslldi ( &__m64  &__m, \'int\'  &__count) {  &_mm_slli_pi32 ( &__m,  &__count); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_m_psllq ( &__m64  &__m,  &__m64  &__count) {  &_mm_sll_si64 ( &__m,  &__count); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_slli_si64 ( &__m64  &__m, \'int\'  &__count) { ( &__m64)  &__builtin_ia32_psllqi (( &__v1di) &__m,  &__count); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_m_psllqi ( &__m64  &__m, \'int\'  &__count) {  &_mm_slli_si64 ( &__m,  &__count); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_m_psraw ( &__m64  &__m,  &__m64  &__count) {  &_mm_sra_pi16 ( &__m,  &__count); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_srai_pi16 ( &__m64  &__m, \'int\'  &__count) { ( &__m64)  &__builtin_ia32_psrawi (( &__v4hi) &__m,  &__count); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_m_psrawi ( &__m64  &__m, \'int\'  &__count) {  &_mm_srai_pi16 ( &__m,  &__count); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_m_psrad ( &__m64  &__m,  &__m64  &__count) {  &_mm_sra_pi32 ( &__m,  &__count); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_srai_pi32 ( &__m64  &__m, \'int\'  &__count) { ( &__m64)  &__builtin_ia32_psradi (( &__v2si) &__m,  &__count); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_m_psradi ( &__m64  &__m, \'int\'  &__count) {  &_mm_srai_pi32 ( &__m,  &__count); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_m_psrlw ( &__m64  &__m,  &__m64  &__count) {  &_mm_srl_pi16 ( &__m,  &__count); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_srli_pi16 ( &__m64  &__m, \'int\'  &__count) { ( &__m64)  &__builtin_ia32_psrlwi (( &__v4hi) &__m,  &__count); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_m_psrlwi ( &__m64  &__m, \'int\'  &__count) {  &_mm_srli_pi16 ( &__m,  &__count); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_m_psrld ( &__m64  &__m,  &__m64  &__count) {  &_mm_srl_pi32 ( &__m,  &__count); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_srli_pi32 ( &__m64  &__m, \'int\'  &__count) { ( &__m64)  &__builtin_ia32_psrldi (( &__v2si) &__m,  &__count); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_m_psrldi ( &__m64  &__m, \'int\'  &__count) {  &_mm_srli_pi32 ( &__m,  &__count); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_m_psrlq ( &__m64  &__m,  &__m64  &__count) {  &_mm_srl_si64 ( &__m,  &__count); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_srli_si64 ( &__m64  &__m, \'int\'  &__count) { ( &__m64)  &__builtin_ia32_psrlqi (( &__v1di) &__m,  &__count); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_m_psrlqi ( &__m64  &__m, \'int\'  &__count) {  &_mm_srli_si64 ( &__m,  &__count); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_m_pand ( &__m64  &__m1,  &__m64  &__m2) {  &_mm_and_si64 ( &__m1,  &__m2); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_m_pandn ( &__m64  &__m1,  &__m64  &__m2) {  &_mm_andnot_si64 ( &__m1,  &__m2); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_m_por ( &__m64  &__m1,  &__m64  &__m2) {  &_mm_or_si64 ( &__m1,  &__m2); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_m_pxor ( &__m64  &__m1,  &__m64  &__m2) {  &_mm_xor_si64 ( &__m1,  &__m2); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_m_pcmpeqb ( &__m64  &__m1,  &__m64  &__m2) {  &_mm_cmpeq_pi8 ( &__m1,  &__m2); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_cmpgt_pi8 ( &__m64  &__m1,  &__m64  &__m2) { ( &__m64)  &__builtin_ia32_pcmpgtb (( &__v8qi) &__m1, ( &__v8qi) &__m2); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_m_pcmpgtb ( &__m64  &__m1,  &__m64  &__m2) {  &_mm_cmpgt_pi8 ( &__m1,  &__m2); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_m_pcmpeqw ( &__m64  &__m1,  &__m64  &__m2) {  &_mm_cmpeq_pi16 ( &__m1,  &__m2); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_cmpgt_pi16 ( &__m64  &__m1,  &__m64  &__m2) { ( &__m64)  &__builtin_ia32_pcmpgtw (( &__v4hi) &__m1, ( &__v4hi) &__m2); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_m_pcmpgtw ( &__m64  &__m1,  &__m64  &__m2) {  &_mm_cmpgt_pi16 ( &__m1,  &__m2); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_m_pcmpeqd ( &__m64  &__m1,  &__m64  &__m2) {  &_mm_cmpeq_pi32 ( &__m1,  &__m2); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_cmpgt_pi32 ( &__m64  &__m1,  &__m64  &__m2) { ( &__m64)  &__builtin_ia32_pcmpgtd (( &__v2si) &__m1, ( &__v2si) &__m2); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_m_pcmpgtd ( &__m64  &__m1,  &__m64  &__m2) {  &_mm_cmpgt_pi32 ( &__m1,  &__m2); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_setr_pi16 (my $__w0, my $__w1, my $__w2, my $__w3) {  &_mm_set_pi16 ( $__w3,  $__w2,  $__w1,  $__w0); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_setr_pi8 (\'char\'  &__b0, \'char\'  &__b1, \'char\'  &__b2, \'char\'  &__b3, \'char\'  &__b4, \'char\'  &__b5, \'char\'  &__b6, \'char\'  &__b7) {  &_mm_set_pi8 ( &__b7,  &__b6,  &__b5,  &__b4,  &__b3,  &__b2,  &__b1,  &__b0); });
    }' unless defined(&__attribute__);
    if(defined(&__DISABLE_MMX__)) {
	undef(&__DISABLE_MMX__) if defined(&__DISABLE_MMX__);
    }
}
1;
