require '_h2ph_pre.ph';

no warnings qw(redefine misc);

if(!defined (&_IMMINTRIN_H_INCLUDED)) {
    die("Never use <movdirintrin.h> directly; include <x86intrin.h> instead.");
}
unless(defined(&_MOVDIRINTRIN_H_INCLUDED)) {
    eval 'sub _MOVDIRINTRIN_H_INCLUDED () {1;}' unless defined(&_MOVDIRINTRIN_H_INCLUDED);
    unless(defined(&__MOVDIRI__)) {
	eval 'sub __DISABLE_MOVDIRI__ () {1;}' unless defined(&__DISABLE_MOVDIRI__);
    }
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_directstoreu_u32 ( &void *  &__P, my $__A) {  &__builtin_ia32_directstoreu_u32 ( &__P,  $__A); });
    }' unless defined(&__attribute__);
    if(defined(&__x86_64__)) {
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_directstoreu_u64 ( &void *  &__P, my $__A) {  &__builtin_ia32_directstoreu_u64 ( &__P,  $__A); });
	}' unless defined(&__attribute__);
    }
    if(defined(&__DISABLE_MOVDIRI__)) {
	undef(&__DISABLE_MOVDIRI__) if defined(&__DISABLE_MOVDIRI__);
    }
    unless(defined(&__MOVDIR64B__)) {
	eval 'sub __DISABLE_MOVDIR64B__ () {1;}' unless defined(&__DISABLE_MOVDIR64B__);
    }
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_movdir64b ( &void *  &__P,  &const  &void *  &__Q) {  &__builtin_ia32_movdir64b ( &__P,  &__Q); });
    }' unless defined(&__attribute__);
    if(defined(&__DISABLE_MOVDIR64B__)) {
	undef(&__DISABLE_MOVDIR64B__) if defined(&__DISABLE_MOVDIR64B__);
    }
}
1;
