require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_IMMINTRIN_H_INCLUDED)) {
    die("Never use <pconfigintrin.h> directly; include <immintrin.h> instead.");
}
unless(defined(&_PCONFIGINTRIN_H_INCLUDED)) {
    eval 'sub _PCONFIGINTRIN_H_INCLUDED () {1;}' unless defined(&_PCONFIGINTRIN_H_INCLUDED);
    unless(defined(&__PCONFIG__)) {
	eval 'sub __DISABLE_PCONFIG__ () {1;}' unless defined(&__DISABLE_PCONFIG__);
    }
    eval 'sub __pconfig_b {
        my($leaf, $b, $retval) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&__pconfig_b);
    eval 'sub __pconfig_generic {
        my($leaf, $b, $c, $d, $retval) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&__pconfig_generic);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_pconfig_u32 ( &const my $__L, \'size_t\'  $__D[]) {  &enum  &__pconfig_type {  &__PCONFIG_KEY_PROGRAM = 0x1, }; my $__R = 0;  &if (! &__builtin_constant_p ( $__L))  &__pconfig_generic ( $__L,  $__D[0],  $__D[1],  $__D[2],  $__R);  &else  &switch ( $__L) {  &case  &__PCONFIG_KEY_PROGRAM:  &__pconfig_b ( $__L,  $__D[0],  $__R);  &break;  &default:  &__pconfig_generic ( $__L,  $__D[0],  $__D[1],  $__D[2],  $__R); }  $__R; });
    }' unless defined(&__attribute__);
    if(defined(&__DISABLE_PCONFIG__)) {
	undef(&__DISABLE_PCONFIG__) if defined(&__DISABLE_PCONFIG__);
    }
}
1;
