require '_h2ph_pre.ph';

no warnings qw(redefine misc);

if(!defined (&_IMMINTRIN_H_INCLUDED)) {
    die("Never use <xsaveintrin.h> directly; include <immintrin.h> instead.");
}
unless(defined(&_XSAVEINTRIN_H_INCLUDED)) {
    eval 'sub _XSAVEINTRIN_H_INCLUDED () {1;}' unless defined(&_XSAVEINTRIN_H_INCLUDED);
    unless(defined(&__XSAVE__)) {
	eval 'sub __DISABLE_XSAVE__ () {1;}' unless defined(&__DISABLE_XSAVE__);
    }
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_xsave ( &void * &__P, my $__M) {  &__builtin_ia32_xsave ( &__P,  $__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_xrstor ( &void * &__P, my $__M) {  &__builtin_ia32_xrstor ( &__P,  $__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_xsetbv (my $__A, my $__V) {  &__builtin_ia32_xsetbv ( $__A,  $__V); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_xgetbv  {  &__builtin_ia32_xgetbv ( &__A); });
    }' unless defined(&__attribute__);
    if(defined(&__x86_64__)) {
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_xsave64 ( &void * &__P, my $__M) {  &__builtin_ia32_xsave64 ( &__P,  $__M); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_xrstor64 ( &void * &__P, my $__M) {  &__builtin_ia32_xrstor64 ( &__P,  $__M); });
	}' unless defined(&__attribute__);
    }
    if(defined(&__DISABLE_XSAVE__)) {
	undef(&__DISABLE_XSAVE__) if defined(&__DISABLE_XSAVE__);
    }
}
1;
