require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_X86_CACHEINFO_H_)) {
    eval 'sub _X86_CACHEINFO_H_ () {1;}' unless defined(&_X86_CACHEINFO_H_);
    unless(defined(&_KERNEL)) {
    }
    eval 'sub CAI_ITLB () {0;}' unless defined(&CAI_ITLB);
    eval 'sub CAI_ITLB2 () {1;}' unless defined(&CAI_ITLB2);
    eval 'sub CAI_DTLB () {2;}' unless defined(&CAI_DTLB);
    eval 'sub CAI_DTLB2 () {3;}' unless defined(&CAI_DTLB2);
    eval 'sub CAI_ICACHE () {4;}' unless defined(&CAI_ICACHE);
    eval 'sub CAI_DCACHE () {5;}' unless defined(&CAI_DCACHE);
    eval 'sub CAI_L2CACHE () {6;}' unless defined(&CAI_L2CACHE);
    eval 'sub CAI_L3CACHE () {7;}' unless defined(&CAI_L3CACHE);
    eval 'sub CAI_L1_1GBITLB () {8;}' unless defined(&CAI_L1_1GBITLB);
    eval 'sub CAI_L1_1GBDTLB () {9;}' unless defined(&CAI_L1_1GBDTLB);
    eval 'sub CAI_L2_1GBITLB () {10;}' unless defined(&CAI_L2_1GBITLB);
    eval 'sub CAI_L2_1GBDTLB () {11;}' unless defined(&CAI_L2_1GBDTLB);
    eval 'sub CAI_L2_ITLB () {12;}' unless defined(&CAI_L2_ITLB);
    eval 'sub CAI_L2_ITLB2 () {13;}' unless defined(&CAI_L2_ITLB2);
    eval 'sub CAI_L2_DTLB () {14;}' unless defined(&CAI_L2_DTLB);
    eval 'sub CAI_L2_DTLB2 () {15;}' unless defined(&CAI_L2_DTLB2);
    eval 'sub CAI_L2_STLB () {16;}' unless defined(&CAI_L2_STLB);
    eval 'sub CAI_L2_STLB2 () {17;}' unless defined(&CAI_L2_STLB2);
    eval 'sub CAI_L2_STLB3 () {18;}' unless defined(&CAI_L2_STLB3);
    eval 'sub CAI_PREFETCH () {19;}' unless defined(&CAI_PREFETCH);
    eval 'sub CAI_L1_LD_TLB () {20;}' unless defined(&CAI_L1_LD_TLB);
    eval 'sub CAI_L1_ST_TLB () {21;}' unless defined(&CAI_L1_ST_TLB);
    eval 'sub CAI_COUNT () {22;}' unless defined(&CAI_COUNT);
    eval 'sub AMD_L1_EAX_DTLB_ASSOC {
        my($x) = @_;
	    eval q(((($x) >> 24) & 0xff));
    }' unless defined(&AMD_L1_EAX_DTLB_ASSOC);
    eval 'sub AMD_L1_EAX_DTLB_ENTRIES {
        my($x) = @_;
	    eval q(((($x) >> 16) & 0xff));
    }' unless defined(&AMD_L1_EAX_DTLB_ENTRIES);
    eval 'sub AMD_L1_EAX_ITLB_ASSOC {
        my($x) = @_;
	    eval q(((($x) >> 8) & 0xff));
    }' unless defined(&AMD_L1_EAX_ITLB_ASSOC);
    eval 'sub AMD_L1_EAX_ITLB_ENTRIES {
        my($x) = @_;
	    eval q(( ($x) & 0xff));
    }' unless defined(&AMD_L1_EAX_ITLB_ENTRIES);
    eval 'sub AMD_L1_EBX_DTLB_ASSOC {
        my($x) = @_;
	    eval q(((($x) >> 24) & 0xff));
    }' unless defined(&AMD_L1_EBX_DTLB_ASSOC);
    eval 'sub AMD_L1_EBX_DTLB_ENTRIES {
        my($x) = @_;
	    eval q(((($x) >> 16) & 0xff));
    }' unless defined(&AMD_L1_EBX_DTLB_ENTRIES);
    eval 'sub AMD_L1_EBX_ITLB_ASSOC {
        my($x) = @_;
	    eval q(((($x) >> 8) & 0xff));
    }' unless defined(&AMD_L1_EBX_ITLB_ASSOC);
    eval 'sub AMD_L1_EBX_ITLB_ENTRIES {
        my($x) = @_;
	    eval q(( ($x) & 0xff));
    }' unless defined(&AMD_L1_EBX_ITLB_ENTRIES);
    eval 'sub AMD_L1_ECX_DC_SIZE {
        my($x) = @_;
	    eval q((((($x) >> 24) & 0xff) * 1024));
    }' unless defined(&AMD_L1_ECX_DC_SIZE);
    eval 'sub AMD_L1_ECX_DC_ASSOC {
        my($x) = @_;
	    eval q(((($x) >> 16) & 0xff));
    }' unless defined(&AMD_L1_ECX_DC_ASSOC);
    eval 'sub AMD_L1_ECX_DC_LPT {
        my($x) = @_;
	    eval q(((($x) >> 8) & 0xff));
    }' unless defined(&AMD_L1_ECX_DC_LPT);
    eval 'sub AMD_L1_ECX_DC_LS {
        my($x) = @_;
	    eval q(( ($x) & 0xff));
    }' unless defined(&AMD_L1_ECX_DC_LS);
    eval 'sub AMD_L1_EDX_IC_SIZE {
        my($x) = @_;
	    eval q((((($x) >> 24) & 0xff) * 1024));
    }' unless defined(&AMD_L1_EDX_IC_SIZE);
    eval 'sub AMD_L1_EDX_IC_ASSOC {
        my($x) = @_;
	    eval q(((($x) >> 16) & 0xff));
    }' unless defined(&AMD_L1_EDX_IC_ASSOC);
    eval 'sub AMD_L1_EDX_IC_LPT {
        my($x) = @_;
	    eval q(((($x) >> 8) & 0xff));
    }' unless defined(&AMD_L1_EDX_IC_LPT);
    eval 'sub AMD_L1_EDX_IC_LS {
        my($x) = @_;
	    eval q(( ($x) & 0xff));
    }' unless defined(&AMD_L1_EDX_IC_LS);
    eval 'sub AMD_L2_EAX_DTLB_ASSOC {
        my($x) = @_;
	    eval q(((($x) >> 28) & 0xf));
    }' unless defined(&AMD_L2_EAX_DTLB_ASSOC);
    eval 'sub AMD_L2_EAX_DTLB_ENTRIES {
        my($x) = @_;
	    eval q(((($x) >> 16) & 0xfff));
    }' unless defined(&AMD_L2_EAX_DTLB_ENTRIES);
    eval 'sub AMD_L2_EAX_IUTLB_ASSOC {
        my($x) = @_;
	    eval q(((($x) >> 12) & 0xf));
    }' unless defined(&AMD_L2_EAX_IUTLB_ASSOC);
    eval 'sub AMD_L2_EAX_IUTLB_ENTRIES {
        my($x) = @_;
	    eval q(( ($x) & 0xfff));
    }' unless defined(&AMD_L2_EAX_IUTLB_ENTRIES);
    eval 'sub AMD_L2_EBX_DTLB_ASSOC {
        my($x) = @_;
	    eval q(((($x) >> 28) & 0xf));
    }' unless defined(&AMD_L2_EBX_DTLB_ASSOC);
    eval 'sub AMD_L2_EBX_DTLB_ENTRIES {
        my($x) = @_;
	    eval q(((($x) >> 16) & 0xfff));
    }' unless defined(&AMD_L2_EBX_DTLB_ENTRIES);
    eval 'sub AMD_L2_EBX_IUTLB_ASSOC {
        my($x) = @_;
	    eval q(((($x) >> 12) & 0xf));
    }' unless defined(&AMD_L2_EBX_IUTLB_ASSOC);
    eval 'sub AMD_L2_EBX_IUTLB_ENTRIES {
        my($x) = @_;
	    eval q(( ($x) & 0xfff));
    }' unless defined(&AMD_L2_EBX_IUTLB_ENTRIES);
    eval 'sub AMD_L2_ECX_C_SIZE {
        my($x) = @_;
	    eval q((((($x) >> 16) & 0xffff) * 1024));
    }' unless defined(&AMD_L2_ECX_C_SIZE);
    eval 'sub AMD_L2_ECX_C_ASSOC {
        my($x) = @_;
	    eval q(((($x) >> 12) & 0xf));
    }' unless defined(&AMD_L2_ECX_C_ASSOC);
    eval 'sub AMD_L2_ECX_C_LPT {
        my($x) = @_;
	    eval q(((($x) >> 8) & 0xf));
    }' unless defined(&AMD_L2_ECX_C_LPT);
    eval 'sub AMD_L2_ECX_C_LS {
        my($x) = @_;
	    eval q(( ($x) & 0xff));
    }' unless defined(&AMD_L2_ECX_C_LS);
    eval 'sub AMD_L3_EDX_C_SIZE {
        my($x) = @_;
	    eval q((((($x) >> 18) & 0xffff) * 1024* 512));
    }' unless defined(&AMD_L3_EDX_C_SIZE);
    eval 'sub AMD_L3_EDX_C_ASSOC {
        my($x) = @_;
	    eval q(((($x) >> 12) & 0xf));
    }' unless defined(&AMD_L3_EDX_C_ASSOC);
    eval 'sub AMD_L3_EDX_C_LPT {
        my($x) = @_;
	    eval q(((($x) >> 8) & 0xf));
    }' unless defined(&AMD_L3_EDX_C_LPT);
    eval 'sub AMD_L3_EDX_C_LS {
        my($x) = @_;
	    eval q(( ($x) & 0xff));
    }' unless defined(&AMD_L3_EDX_C_LS);
    eval 'sub AMD_L1_1GB_EAX_DTLB_ASSOC {
        my($x) = @_;
	    eval q(((($x) >> 28) & 0xf));
    }' unless defined(&AMD_L1_1GB_EAX_DTLB_ASSOC);
    eval 'sub AMD_L1_1GB_EAX_DTLB_ENTRIES {
        my($x) = @_;
	    eval q(((($x) >> 16) & 0xfff));
    }' unless defined(&AMD_L1_1GB_EAX_DTLB_ENTRIES);
    eval 'sub AMD_L1_1GB_EAX_IUTLB_ASSOC {
        my($x) = @_;
	    eval q(((($x) >> 12) & 0xf));
    }' unless defined(&AMD_L1_1GB_EAX_IUTLB_ASSOC);
    eval 'sub AMD_L1_1GB_EAX_IUTLB_ENTRIES {
        my($x) = @_;
	    eval q(( ($x) & 0xfff));
    }' unless defined(&AMD_L1_1GB_EAX_IUTLB_ENTRIES);
    eval 'sub AMD_L2_1GB_EBX_DUTLB_ASSOC {
        my($x) = @_;
	    eval q(((($x) >> 28) & 0xf));
    }' unless defined(&AMD_L2_1GB_EBX_DUTLB_ASSOC);
    eval 'sub AMD_L2_1GB_EBX_DUTLB_ENTRIES {
        my($x) = @_;
	    eval q(((($x) >> 16) & 0xfff));
    }' unless defined(&AMD_L2_1GB_EBX_DUTLB_ENTRIES);
    eval 'sub AMD_L2_1GB_EBX_IUTLB_ASSOC {
        my($x) = @_;
	    eval q(((($x) >> 12) & 0xf));
    }' unless defined(&AMD_L2_1GB_EBX_IUTLB_ASSOC);
    eval 'sub AMD_L2_1GB_EBX_IUTLB_ENTRIES {
        my($x) = @_;
	    eval q(( ($x) & 0xfff));
    }' unless defined(&AMD_L2_1GB_EBX_IUTLB_ENTRIES);
    eval 'sub VIA_L1_EBX_DTLB_ASSOC {
        my($x) = @_;
	    eval q(((($x) >> 24) & 0xff));
    }' unless defined(&VIA_L1_EBX_DTLB_ASSOC);
    eval 'sub VIA_L1_EBX_DTLB_ENTRIES {
        my($x) = @_;
	    eval q(((($x) >> 16) & 0xff));
    }' unless defined(&VIA_L1_EBX_DTLB_ENTRIES);
    eval 'sub VIA_L1_EBX_ITLB_ASSOC {
        my($x) = @_;
	    eval q(((($x) >> 8) & 0xff));
    }' unless defined(&VIA_L1_EBX_ITLB_ASSOC);
    eval 'sub VIA_L1_EBX_ITLB_ENTRIES {
        my($x) = @_;
	    eval q(( ($x) & 0xff));
    }' unless defined(&VIA_L1_EBX_ITLB_ENTRIES);
    eval 'sub VIA_L1_ECX_DC_SIZE {
        my($x) = @_;
	    eval q((((($x) >> 24) & 0xff) * 1024));
    }' unless defined(&VIA_L1_ECX_DC_SIZE);
    eval 'sub VIA_L1_ECX_DC_ASSOC {
        my($x) = @_;
	    eval q(((($x) >> 16) & 0xff));
    }' unless defined(&VIA_L1_ECX_DC_ASSOC);
    eval 'sub VIA_L1_ECX_DC_LPT {
        my($x) = @_;
	    eval q(((($x) >> 8) & 0xff));
    }' unless defined(&VIA_L1_ECX_DC_LPT);
    eval 'sub VIA_L1_ECX_DC_LS {
        my($x) = @_;
	    eval q(( ($x) & 0xff));
    }' unless defined(&VIA_L1_ECX_DC_LS);
    eval 'sub VIA_L1_EDX_IC_SIZE {
        my($x) = @_;
	    eval q((((($x) >> 24) & 0xff) * 1024));
    }' unless defined(&VIA_L1_EDX_IC_SIZE);
    eval 'sub VIA_L1_EDX_IC_ASSOC {
        my($x) = @_;
	    eval q(((($x) >> 16) & 0xff));
    }' unless defined(&VIA_L1_EDX_IC_ASSOC);
    eval 'sub VIA_L1_EDX_IC_LPT {
        my($x) = @_;
	    eval q(((($x) >> 8) & 0xff));
    }' unless defined(&VIA_L1_EDX_IC_LPT);
    eval 'sub VIA_L1_EDX_IC_LS {
        my($x) = @_;
	    eval q(( ($x) & 0xff));
    }' unless defined(&VIA_L1_EDX_IC_LS);
    eval 'sub VIA_L2_ECX_C_SIZE {
        my($x) = @_;
	    eval q((((($x) >> 24) & 0xff) * 1024));
    }' unless defined(&VIA_L2_ECX_C_SIZE);
    eval 'sub VIA_L2_ECX_C_ASSOC {
        my($x) = @_;
	    eval q(((($x) >> 16) & 0xff));
    }' unless defined(&VIA_L2_ECX_C_ASSOC);
    eval 'sub VIA_L2_ECX_C_LPT {
        my($x) = @_;
	    eval q(((($x) >> 8) & 0xff));
    }' unless defined(&VIA_L2_ECX_C_LPT);
    eval 'sub VIA_L2_ECX_C_LS {
        my($x) = @_;
	    eval q(( ($x) & 0xff));
    }' unless defined(&VIA_L2_ECX_C_LS);
    eval 'sub VIA_L2N_ECX_C_SIZE {
        my($x) = @_;
	    eval q((((($x) >> 16) & 0xffff) * 1024));
    }' unless defined(&VIA_L2N_ECX_C_SIZE);
    eval 'sub VIA_L2N_ECX_C_ASSOC {
        my($x) = @_;
	    eval q(((($x) >> 12) & 0xf));
    }' unless defined(&VIA_L2N_ECX_C_ASSOC);
    eval 'sub VIA_L2N_ECX_C_LPT {
        my($x) = @_;
	    eval q(((($x) >> 8) & 0xf));
    }' unless defined(&VIA_L2N_ECX_C_LPT);
    eval 'sub VIA_L2N_ECX_C_LS {
        my($x) = @_;
	    eval q(( ($x) & 0xff));
    }' unless defined(&VIA_L2N_ECX_C_LS);
    if(defined(&_KERNEL)) {
	eval 'sub __CI_TBL {
	    my($a,$b,$c,$d,$e,$f) = @_;
    	    eval q({ $a, $b, $c, $d, $e });
	}' unless defined(&__CI_TBL);
    } else {
	eval 'sub __CI_TBL {
	    my($a,$b,$c,$d,$e,$f) = @_;
    	    eval q({ $a, $b, $c, $d, $e, $f });
	}' unless defined(&__CI_TBL);
    }
    eval 'sub INTEL_CACHE_INFO () {{  &__CI_TBL( &CAI_ITLB, 0x1, 4, 32, 4* 1024,  &NULL),  &__CI_TBL( &CAI_ITLB2, 0x2, 0xff, 2, 4* 1024* 1024,  &NULL),  &__CI_TBL( &CAI_DTLB, 0x3, 4, 64, 4* 1024,  &NULL),  &__CI_TBL( &CAI_DTLB2, 0x4, 4, 8, 4* 1024* 1024,  &NULL),  &__CI_TBL( &CAI_DTLB2, 0x5, 4, 32, 4* 1024* 1024,  &NULL),  &__CI_TBL( &CAI_ITLB2, 0xb, 4, 4, 4* 1024* 1024,  &NULL),  &__CI_TBL( &CAI_ITLB, 0x4f, 0xff, 32, 4* 1024,  &NULL),  &__CI_TBL( &CAI_ITLB, 0x50, 0xff, 64, 4* 1024, "64 4K/4M entries"),  &__CI_TBL( &CAI_ITLB, 0x51, 0xff, 64, 4* 1024, "128 4K/4M entries"), &__CI_TBL( &CAI_ITLB, 0x52, 0xff, 64, 4* 1024, "256 4K/4M entries"), &__CI_TBL( &CAI_ITLB2, 0x55, 0xff, 64, 4* 1024, "7 2M/4M entries"),  &__CI_TBL( &CAI_DTLB2, 0x56, 4, 16, 4* 1024* 1024,  &NULL),  &__CI_TBL( &CAI_DTLB, 0x57, 4, 16, 4* 1024,  &NULL),  &__CI_TBL( &CAI_DTLB, 0x59, 0xff, 16, 4* 1024,  &NULL),  &__CI_TBL( &CAI_DTLB2, 0x5a, 0xff, 64, 4* 1024, "32 2M/4M entries (L0)"),  &__CI_TBL( &CAI_DTLB, 0x5b, 0xff, 64, 4* 1024, "64 4K/4M entries"),  &__CI_TBL( &CAI_DTLB, 0x5c, 0xff, 64, 4* 1024, "128 4K/4M entries"), &__CI_TBL( &CAI_DTLB, 0x5d, 0xff, 64, 4* 1024, "256 4K/4M entries"), &__CI_TBL( &CAI_ITLB, 0x61, 0xff, 48, 4* 1024,  &NULL),  &__CI_TBL( &CAI_L1_1GBDTLB,0x63, 4, 4,1024*1024* 1024,  &NULL),  &__CI_TBL( &CAI_DTLB, 0x64, 4,512, 4* 1024,  &NULL),  &__CI_TBL( &CAI_ITLB, 0x6a, 8, 64, 4* 1024,  &NULL),  &__CI_TBL( &CAI_DTLB, 0x6b, 8,256, 4* 1024,  &NULL),  &__CI_TBL( &CAI_L2_DTLB2, 0x6c, 8,128, 0, "128 2M/4M entries"), &__CI_TBL( &CAI_L1_1GBDTLB,0x6d,0xff, 16,1024*1024* 1024,  &NULL),  &__CI_TBL( &CAI_ITLB2, 0x76, 0xff, 8, 4* 1024* 1024, "8 2M/4M entries"),  &__CI_TBL( &CAI_DTLB, 0xa0, 0xff, 32, 4* 1024,  &NULL),  &__CI_TBL( &CAI_ITLB, 0xb0, 4,128, 4* 1024,  &NULL),  &__CI_TBL( &CAI_ITLB2, 0xb1, 4, 64, 0, "8 2M & 4 4M entries"),  &__CI_TBL( &CAI_ITLB, 0xb2, 4, 64, 4* 1024,  &NULL),  &__CI_TBL( &CAI_DTLB, 0xb3, 4,128, 4* 1024,  &NULL),  &__CI_TBL( &CAI_DTLB, 0xb4, 4,256, 4* 1024,  &NULL),  &__CI_TBL( &CAI_ITLB, 0xb5, 8, 64, 4* 1024,  &NULL),  &__CI_TBL( &CAI_ITLB, 0xb6, 8,128, 4* 1024,  &NULL),  &__CI_TBL( &CAI_DTLB, 0xba, 4, 64, 4* 1024,  &NULL),  &__CI_TBL( &CAI_DTLB2, 0xc0, 4, 8, 4* 1024, "8 4K/4M entries"),  &__CI_TBL( &CAI_L2_STLB2, 0xc1, 8,1024, 4* 1024, "1024 4K/2M entries"),  &__CI_TBL( &CAI_DTLB2, 0xc2, 4, 16, 4* 1024, "16 4K/2M entries"),  &__CI_TBL( &CAI_L2_STLB, 0xc3, 6,1536, 4* 1024,  &NULL),  &__CI_TBL( &CAI_DTLB2, 0xc4, 4, 32, 4* 1024, "32 2M/4M entries"),  &__CI_TBL( &CAI_L2_STLB, 0xca, 4,512, 4* 1024,  &NULL),  &__CI_TBL( &CAI_ICACHE, 0x6, 4, 8* 1024, 32,  &NULL),  &__CI_TBL( &CAI_ICACHE, 0x8, 4, 16* 1024, 32,  &NULL),  &__CI_TBL( &CAI_ICACHE, 0x9, 4, 32* 1024, 64,  &NULL),  &__CI_TBL( &CAI_DCACHE, 0xa, 2, 8* 1024, 32,  &NULL),  &__CI_TBL( &CAI_DCACHE, 0xc, 4, 16* 1024, 32,  &NULL),  &__CI_TBL( &CAI_DCACHE, 0xd, 4, 16* 1024, 64,  &NULL),  &__CI_TBL( &CAI_DCACHE, 0xe, 6, 24* 1024, 64,  &NULL),  &__CI_TBL( &CAI_L2CACHE, 0x21, 8, 256* 1024, 64,  &NULL),  &__CI_TBL( &CAI_L3CACHE, 0x22, 0xff, 512* 1024, 64, "sectored, 4-way "),  &__CI_TBL( &CAI_L3CACHE, 0x23, 0xff, 1* 1024* 1024, 64, "sectored, 8-way "),  &__CI_TBL( &CAI_L2CACHE, 0x24, 16, 1* 1024* 1024, 64,  &NULL),  &__CI_TBL( &CAI_L3CACHE, 0x25, 0xff, 2* 1024* 1024, 64, "sectored, 8-way "),  &__CI_TBL( &CAI_L3CACHE, 0x29, 0xff, 4* 1024* 1024, 64, "sectored, 8-way "),  &__CI_TBL( &CAI_DCACHE, 0x2c, 8, 32* 1024, 64,  &NULL),  &__CI_TBL( &CAI_ICACHE, 0x30, 8, 32* 1024, 64,  &NULL),  &__CI_TBL( &CAI_L2CACHE, 0x39, 4, 128* 1024, 64,  &NULL),  &__CI_TBL( &CAI_L2CACHE, 0x3a, 6, 192* 1024, 64,  &NULL),  &__CI_TBL( &CAI_L2CACHE, 0x3b, 2, 128* 1024, 64,  &NULL),  &__CI_TBL( &CAI_L2CACHE, 0x3c, 4, 256* 1024, 64,  &NULL),  &__CI_TBL( &CAI_L2CACHE, 0x3d, 6, 384* 1024, 64,  &NULL),  &__CI_TBL( &CAI_L2CACHE, 0x3e, 4, 512* 1024, 64,  &NULL),  &__CI_TBL( &CAI_L2CACHE, 0x40, 0, 0, 0, "not present"),  &__CI_TBL( &CAI_L2CACHE, 0x41, 4, 128* 1024, 32,  &NULL),  &__CI_TBL( &CAI_L2CACHE, 0x42, 4, 256* 1024, 32,  &NULL),  &__CI_TBL( &CAI_L2CACHE, 0x43, 4, 512* 1024, 32,  &NULL),  &__CI_TBL( &CAI_L2CACHE, 0x44, 4, 1* 1024* 1024, 32,  &NULL),  &__CI_TBL( &CAI_L2CACHE, 0x45, 4, 2* 1024* 1024, 32,  &NULL),  &__CI_TBL( &CAI_L3CACHE, 0x46, 4, 4* 1024* 1024, 64,  &NULL),  &__CI_TBL( &CAI_L3CACHE, 0x47, 8, 8* 1024* 1024, 64,  &NULL),  &__CI_TBL( &CAI_L2CACHE, 0x48, 12, 3* 1024* 1024, 64,  &NULL),  &__CI_TBL( &CAI_L2CACHE, 0x49, 16, 4* 1024* 1024, 64,  &NULL),  &__CI_TBL( &CAI_L3CACHE, 0x49, 16, 4* 1024* 1024, 64,  &NULL),  &__CI_TBL( &CAI_L3CACHE, 0x4a, 12, 6* 1024* 1024, 64,  &NULL),  &__CI_TBL( &CAI_L3CACHE, 0x4b, 16, 8* 1024* 1024, 64,  &NULL),  &__CI_TBL( &CAI_L3CACHE, 0x4c, 12,12* 1024* 1024, 64,  &NULL),  &__CI_TBL( &CAI_L3CACHE, 0x4d, 16,16* 1024* 1024, 64,  &NULL),  &__CI_TBL( &CAI_L2CACHE, 0x4e, 24, 6* 1024* 1024, 64,  &NULL),  &__CI_TBL( &CAI_DCACHE, 0x60, 8, 16* 1024, 64,  &NULL),  &__CI_TBL( &CAI_DCACHE, 0x66, 4, 8* 1024, 64,  &NULL),  &__CI_TBL( &CAI_DCACHE, 0x67, 4, 16* 1024, 64,  &NULL),  &__CI_TBL( &CAI_DCACHE, 0x68, 4, 32* 1024, 64,  &NULL),  &__CI_TBL( &CAI_ICACHE, 0x70, 8, 12* 1024, 64, "12K uOp cache"),  &__CI_TBL( &CAI_ICACHE, 0x71, 8, 16* 1024, 64, "16K uOp cache"),  &__CI_TBL( &CAI_ICACHE, 0x72, 8, 32* 1024, 64, "32K uOp cache"),  &__CI_TBL( &CAI_ICACHE, 0x73, 8, 64* 1024, 64, "64K uOp cache"),  &__CI_TBL( &CAI_L2CACHE, 0x78, 4, 1* 1024* 1024, 64,  &NULL),  &__CI_TBL( &CAI_L2CACHE, 0x79, 8, 128* 1024, 64,  &NULL),  &__CI_TBL( &CAI_L2CACHE, 0x7a, 8, 256* 1024, 64,  &NULL),  &__CI_TBL( &CAI_L2CACHE, 0x7b, 8, 512* 1024, 64,  &NULL),  &__CI_TBL( &CAI_L2CACHE, 0x7c, 8, 1* 1024* 1024, 64,  &NULL),  &__CI_TBL( &CAI_L2CACHE, 0x7d, 8, 2* 1024* 1024, 64,  &NULL),  &__CI_TBL( &CAI_L2CACHE, 0x7f, 2, 512* 1024, 64,  &NULL),  &__CI_TBL( &CAI_L2CACHE, 0x80, 8, 512* 1024, 64,  &NULL),  &__CI_TBL( &CAI_L2CACHE, 0x82, 8, 256* 1024, 32,  &NULL),  &__CI_TBL( &CAI_L2CACHE, 0x83, 8, 512* 1024, 32,  &NULL),  &__CI_TBL( &CAI_L2CACHE, 0x84, 8, 1* 1024* 1024, 32,  &NULL),  &__CI_TBL( &CAI_L2CACHE, 0x85, 8, 2* 1024* 1024, 32,  &NULL),  &__CI_TBL( &CAI_L2CACHE, 0x86, 4, 512* 1024, 64,  &NULL),  &__CI_TBL( &CAI_L2CACHE, 0x87, 8, 1* 1024* 1024, 64,  &NULL),  &__CI_TBL( &CAI_L3CACHE, 0xd0, 4, 512* 1024, 64,  &NULL),  &__CI_TBL( &CAI_L3CACHE, 0xd1, 4, 1* 1024* 1024, 64,  &NULL),  &__CI_TBL( &CAI_L3CACHE, 0xd2, 4, 2* 1024* 1024, 64,  &NULL),  &__CI_TBL( &CAI_L3CACHE, 0xd6, 8, 1* 1024* 1024, 64,  &NULL),  &__CI_TBL( &CAI_L3CACHE, 0xd7, 8, 2* 1024* 1024, 64,  &NULL),  &__CI_TBL( &CAI_L3CACHE, 0xd8, 8, 4* 1024* 1024, 64,  &NULL),  &__CI_TBL( &CAI_L3CACHE, 0xdc, 12, 3* 512* 1024, 64,  &NULL),  &__CI_TBL( &CAI_L3CACHE, 0xdd, 12, 3* 1024* 1024, 64,  &NULL),  &__CI_TBL( &CAI_L3CACHE, 0xde, 12, 6* 1024* 1024, 64,  &NULL),  &__CI_TBL( &CAI_L3CACHE, 0xe2, 16, 2* 1024* 1024, 64,  &NULL),  &__CI_TBL( &CAI_L3CACHE, 0xe3, 16, 4* 1024* 1024, 64,  &NULL),  &__CI_TBL( &CAI_L3CACHE, 0xe4, 16, 8* 1024* 1024, 64,  &NULL),  &__CI_TBL( &CAI_L3CACHE, 0xea, 24,12* 1024* 1024, 64,  &NULL),  &__CI_TBL( &CAI_L3CACHE, 0xeb, 24,18* 1024* 1024, 64,  &NULL),  &__CI_TBL( &CAI_L3CACHE, 0xec, 24,24* 1024* 1024, 64,  &NULL),  &__CI_TBL( &CAI_PREFETCH, 0xf0, 0, 0, 64,  &NULL),  &__CI_TBL( &CAI_PREFETCH, 0xf1, 0, 0,128,  &NULL),  &__CI_TBL(0, 0, 0, 0, 0,  &NULL) };}' unless defined(&INTEL_CACHE_INFO);
    eval 'sub AMD_L2L3CACHE_INFO () {{  &__CI_TBL(0, 0x1, 1, 0, 0,  &NULL),  &__CI_TBL(0, 0x2, 2, 0, 0,  &NULL),  &__CI_TBL(0, 0x3, 3, 0, 0,  &NULL),  &__CI_TBL(0, 0x4, 4, 0, 0,  &NULL),  &__CI_TBL(0, 0x5, 6, 0, 0,  &NULL),  &__CI_TBL(0, 0x6, 8, 0, 0,  &NULL),  &__CI_TBL(0, 0x8, 16, 0, 0,  &NULL),  &__CI_TBL(0, 0xa, 32, 0, 0,  &NULL),  &__CI_TBL(0, 0xb, 48, 0, 0,  &NULL),  &__CI_TBL(0, 0xc, 64, 0, 0,  &NULL),  &__CI_TBL(0, 0xd, 96, 0, 0,  &NULL),  &__CI_TBL(0, 0xe, 128, 0, 0,  &NULL),  &__CI_TBL(0, 0xf, 0xff, 0, 0,  &NULL),  &__CI_TBL(0, 0x, 0, 0, 0,  &NULL) };}' unless defined(&AMD_L2L3CACHE_INFO);
}
1;
