require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_X86_INTR_H_)) {
    eval 'sub _X86_INTR_H_ () {1;}' unless defined(&_X86_INTR_H_);
    eval 'sub __HAVE_FAST_SOFTINTS () {1;}' unless defined(&__HAVE_FAST_SOFTINTS);
    if(!defined(&NO_PREEMPTION)) {
	eval 'sub __HAVE_PREEMPTION () {1;}' unless defined(&__HAVE_PREEMPTION);
    }
    if(defined(&_KERNEL)) {
	require 'sys/types.ph';
	require 'sys/kcpuset.ph';
    } else {
	require 'stdbool.ph';
    }
    require 'sys/evcnt.ph';
    require 'sys/queue.ph';
    require 'machine/intrdefs.ph';
    if(defined(&XEN)) {
	require 'xen/include/public/xen.ph';
	require 'xen/include/public/event_channel.ph';
    }
    unless(defined(&_LOCORE)) {
	require 'machine/pic.ph';
	if(defined(&XEN)) {
	}
	eval 'sub IS_LEGACY () {0x1;}' unless defined(&IS_LEGACY);
	eval 'sub IS_IPI () {0x2;}' unless defined(&IS_IPI);
	eval 'sub IS_LOG () {0x4;}' unless defined(&IS_LOG);
	if(defined(&XEN)) {
	}
	if(defined(&_KERNEL)) {
	    eval 'sub APIC_LEVEL {
	        my($l) = @_;
    		eval q((($l) << 4));
	    }' unless defined(&APIC_LEVEL);
	    eval 'sub SPL_ASSERT_BELOW {
	        my($x) = @_;
    		eval q( &KDASSERT( &curcpu()-> &ci_ilevel < ($x)));
	    }' unless defined(&SPL_ASSERT_BELOW);
	    eval 'sub spl0 () {
	        eval q( &spllower( &IPL_NONE));
	    }' unless defined(&spl0);
	    eval 'sub splx {
	        my($x) = @_;
    		eval q( &spllower($x));
	    }' unless defined(&splx);
	    eval 'sub makeiplcookie {
	        my($ipl) = @_;
    		eval q({ ( &ipl_cookie_t){. &_ipl = $ipl}; });
	    }' unless defined(&makeiplcookie);
	    eval 'sub splraiseipl {
	        my($icookie) = @_;
    		eval q({  &splraise( ($icookie->{_ipl})); });
	    }' unless defined(&splraiseipl);
	    require 'sys/spl.ph';
	    unless(defined(&XENPV)) {
	    }
	}
    }
}
1;
