require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_X86_PTE_H)) {
    eval 'sub _X86_PTE_H () {1;}' unless defined(&_X86_PTE_H);
    unless(defined(&_MACHINE_PTE_H_X86)) {
	die("Use\ machine\/pte\.h\,\ not\ x86\/pte\.h\ directly\.");
    }
    eval 'sub PGC_WB () {0;}' unless defined(&PGC_WB);
    eval 'sub PGC_WC () { &PTE_PWT;}' unless defined(&PGC_WC);
    eval 'sub PGC_UCMINUS () { &PTE_PCD;}' unless defined(&PGC_UCMINUS);
    eval 'sub PGC_UC () {( &PTE_PWT |  &PTE_PCD);}' unless defined(&PGC_UC);
    eval 'sub PGEX_P () {0x1;}' unless defined(&PGEX_P);
    eval 'sub PGEX_W () {0x2;}' unless defined(&PGEX_W);
    eval 'sub PGEX_U () {0x4;}' unless defined(&PGEX_U);
    eval 'sub PGEX_RSVD () {0x8;}' unless defined(&PGEX_RSVD);
    eval 'sub PGEX_I () {0x10;}' unless defined(&PGEX_I);
    eval 'sub PGEX_PK () {0x20;}' unless defined(&PGEX_PK);
    eval 'sub PGEX_SGX () {0x8000;}' unless defined(&PGEX_SGX);
    eval 'sub pl1_pi {
        my($VA) = @_;
	    eval q(((( &VA_SIGN_POS($VA)) &  &L1_MASK) >>  &L1_SHIFT));
    }' unless defined(&pl1_pi);
    eval 'sub pl2_pi {
        my($VA) = @_;
	    eval q(((( &VA_SIGN_POS($VA)) &  &L2_MASK) >>  &L2_SHIFT));
    }' unless defined(&pl2_pi);
    eval 'sub pl3_pi {
        my($VA) = @_;
	    eval q(((( &VA_SIGN_POS($VA)) &  &L3_MASK) >>  &L3_SHIFT));
    }' unless defined(&pl3_pi);
    eval 'sub pl4_pi {
        my($VA) = @_;
	    eval q(((( &VA_SIGN_POS($VA)) &  &L4_MASK) >>  &L4_SHIFT));
    }' unless defined(&pl4_pi);
    eval 'sub pl_pi {
        my($va, $lvl) = @_;
	    eval q(((( &VA_SIGN_POS($va)) &  $ptp_masks[($lvl)-1]) >>  $ptp_shifts[($lvl)-1]));
    }' unless defined(&pl_pi);
    eval 'sub pl1_i {
        my($VA) = @_;
	    eval q(((( &VA_SIGN_POS($VA)) &  &L1_FRAME) >>  &L1_SHIFT));
    }' unless defined(&pl1_i);
    eval 'sub pl2_i {
        my($VA) = @_;
	    eval q(((( &VA_SIGN_POS($VA)) &  &L2_FRAME) >>  &L2_SHIFT));
    }' unless defined(&pl2_i);
    eval 'sub pl3_i {
        my($VA) = @_;
	    eval q(((( &VA_SIGN_POS($VA)) &  &L3_FRAME) >>  &L3_SHIFT));
    }' unless defined(&pl3_i);
    eval 'sub pl4_i {
        my($VA) = @_;
	    eval q(((( &VA_SIGN_POS($VA)) &  &L4_FRAME) >>  &L4_SHIFT));
    }' unless defined(&pl4_i);
}
1;
