require '_h2ph_pre.ph';

no warnings qw(redefine misc);

if(defined(&__x86_64__)) {
    if(defined(&_KERNEL_OPT)) {
	require './amd64/opt_xen.ph';
    }
    eval 'sub _MCOUNT_DECL () { &void  &_mcount;}' unless defined(&_MCOUNT_DECL);
    eval 'sub EPROL_EXPORT () { &__asm(".globl _eprol");}' unless defined(&EPROL_EXPORT);
    if(defined(&__PIC__)) {
	eval 'sub __MCPLT () {"@PLT";}' unless defined(&__MCPLT);
    } else {
	eval 'sub __MCPLT () {1;}' unless defined(&__MCPLT);
    }
    eval 'sub MCOUNT () { &__weak_alias( &mcount,  &__mcount)  &__asm(" .globl __mcount		\\n" "	.type __mcount,@function\\n" "__mcount:			\\n" "	pushq	%rbp		\\n" "	movq	%rsp,%rbp	\\n" "	subq	$56,%rsp	\\n" "	movq	%rdi,0(%rsp)	\\n" "	movq	%rsi,8(%rsp)	\\n" "	movq	%rdx,16(%rsp)	\\n" "	movq	%rcx,24(%rsp)	\\n" "	movq	%r8,32(%rsp)	\\n" "	movq	%r9,40(%rsp)	\\n" "	movq	%rax,48(%rsp)	\\n" "	movq	0(%rbp),%r11	\\n" "	movq	8(%r11),%rdi	\\n" "	movq	8(%rbp),%rsi	\\n" "	call	_mcount" &__MCPLT "	\\n" "	movq	0(%rsp),%rdi	\\n" "	movq	8(%rsp),%rsi	\\n" "	movq	16(%rsp),%rdx	\\n" "	movq	24(%rsp),%rcx	\\n" "	movq	32(%rsp),%r8	\\n" "	movq	40(%rsp),%r9	\\n" "	movq	48(%rsp),%rax	\\n" "	leave			\\n" "	ret			\\n" "	.size __mcount,.-__mcount");;}' unless defined(&MCOUNT);
    if(defined(&_KERNEL)) {
	if(defined(&XENPV)) {
	    eval 'sub mcount_disable_intr {
	        my($void) = @_;
    		eval q({  &curcpu()-> ($ci_vcpu->{evtchn_upcall_mask}) = 1;  &__asm  &volatile(\\"lfence\\" ::: \\"memory\\"); });
	    }' unless defined(&mcount_disable_intr);
	    eval 'sub mcount_read_psl {
	        my($void) = @_;
    		eval q({ ( &curcpu()-> ($ci_vcpu->{evtchn_upcall_mask})); });
	    }' unless defined(&mcount_read_psl);
	    eval 'sub mcount_read_psl {
	        my($void) = @_;
    		eval q({ my $ef;  &__asm  &volatile(\\"pushfq; popq %0\\" : \\"=r\\" ( $ef)); ( $ef); });
	    }' unless defined(&mcount_read_psl);
	    eval 'sub mcount_write_psl {
	        my($ef) = @_;
    		eval q({  &__asm  &volatile(\\"pushq %0; popfq\\" : : \\"r\\" ($ef)); });
	    }' unless defined(&mcount_write_psl);
	}
	eval 'sub MCOUNT_ENTER () { &do {  &s =  &mcount_read_psl();  &mcount_disable_intr(); }  &while (0);}' unless defined(&MCOUNT_ENTER);
	eval 'sub MCOUNT_EXIT () { &do {  &mcount_write_psl( &s); }  &while (0);}' unless defined(&MCOUNT_EXIT);
    }
} else {
    require 'i386/profile.ph';
}
1;
