require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_AMD64_SIGNAL_H_)) {
    eval 'sub _AMD64_SIGNAL_H_ () {1;}' unless defined(&_AMD64_SIGNAL_H_);
    if(defined(&__x86_64__)) {
	require 'sys/featuretest.ph';
	if(defined(&_KERNEL)) {
	    eval 'sub __HAVE_STRUCT_SIGCONTEXT () {1;}' unless defined(&__HAVE_STRUCT_SIGCONTEXT);
	}
	if(defined(&_NETBSD_SOURCE)) {
	    require 'machine/trap.ph';
	    require 'machine/mcontext.ph';
	    if(defined(&_KERNEL_OPT)) {
		require './amd64/opt_compat_netbsd.ph';
		require './amd64/opt_compat_netbsd32.ph';
	    }
	}
    } else {
	require 'i386/signal.ph';
    }
}
1;
