require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_IMMINTRIN_H_INCLUDED)) {
    die("Never use <avx512bf16intrin.h> directly; include <immintrin.h> instead.");
}
unless(defined(&_AVX512BF16INTRIN_H_INCLUDED)) {
    eval 'sub _AVX512BF16INTRIN_H_INCLUDED () {1;}' unless defined(&_AVX512BF16INTRIN_H_INCLUDED);
    unless(defined(&__AVX512BF16__)) {
	eval 'sub __DISABLE_AVX512BF16__ () {1;}' unless defined(&__DISABLE_AVX512BF16__);
    }
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cvtne2ps_pbh ( &__m512bh  &__A,  &__mmask32  &__B,  &__m512  &__C,  &__m512  &__D) { ( &__m512bh) &__builtin_ia32_cvtne2ps2bf16_v32hi_mask( &__C,  &__D,  &__A,  &__B); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_cvtne2ps_pbh ( &__mmask32  &__A,  &__m512  &__B,  &__m512  &__C) { ( &__m512bh) &__builtin_ia32_cvtne2ps2bf16_v32hi_maskz( &__B,  &__C,  &__A); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cvtneps_pbh ( &__m256bh  &__A,  &__mmask16  &__B,  &__m512  &__C) { ( &__m256bh) &__builtin_ia32_cvtneps2bf16_v16sf_mask( &__C,  &__A,  &__B); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_cvtneps_pbh ( &__mmask16  &__A,  &__m512  &__B) { ( &__m256bh) &__builtin_ia32_cvtneps2bf16_v16sf_maskz( &__B,  &__A); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_dpbf16_ps ( &__m512  &__A,  &__mmask16  &__B,  &__m512bh  &__C,  &__m512bh  &__D) { ( &__m512) &__builtin_ia32_dpbf16ps_v16sf_mask( &__A,  &__C,  &__D,  &__B); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_dpbf16_ps ( &__mmask16  &__A,  &__m512  &__B,  &__m512bh  &__C,  &__m512bh  &__D) { ( &__m512) &__builtin_ia32_dpbf16ps_v16sf_maskz( &__B,  &__C,  &__D,  &__A); });
    }' unless defined(&__attribute__);
    if(defined(&__DISABLE_AVX512BF16__)) {
	undef(&__DISABLE_AVX512BF16__) if defined(&__DISABLE_AVX512BF16__);
    }
}
1;
