require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_IMMINTRIN_H_INCLUDED)) {
    die("Never use <avx512ifmaintrin.h> directly; include <immintrin.h> instead.");
}
unless(defined(&_AVX512IFMAINTRIN_H_INCLUDED)) {
    eval 'sub _AVX512IFMAINTRIN_H_INCLUDED () {1;}' unless defined(&_AVX512IFMAINTRIN_H_INCLUDED);
    unless(defined(&__AVX512IFMA__)) {
	eval 'sub __DISABLE_AVX512IFMA__ () {1;}' unless defined(&__DISABLE_AVX512IFMA__);
    }
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_madd52lo_epu64 ( &__m512i  &__X,  &__m512i  &__Y,  &__m512i  &__Z) { ( &__m512i)  &__builtin_ia32_vpmadd52luq512_mask (( &__v8di)  &__X, ( &__v8di)  &__Y, ( &__v8di)  &__Z, ( &__mmask8) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_madd52hi_epu64 ( &__m512i  &__X,  &__m512i  &__Y,  &__m512i  &__Z) { ( &__m512i)  &__builtin_ia32_vpmadd52huq512_mask (( &__v8di)  &__X, ( &__v8di)  &__Y, ( &__v8di)  &__Z, ( &__mmask8) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_madd52lo_epu64 ( &__m512i  &__W,  &__mmask8  &__M,  &__m512i  &__X,  &__m512i  &__Y) { ( &__m512i)  &__builtin_ia32_vpmadd52luq512_mask (( &__v8di)  &__W, ( &__v8di)  &__X, ( &__v8di)  &__Y, ( &__mmask8)  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_madd52hi_epu64 ( &__m512i  &__W,  &__mmask8  &__M,  &__m512i  &__X,  &__m512i  &__Y) { ( &__m512i)  &__builtin_ia32_vpmadd52huq512_mask (( &__v8di)  &__W, ( &__v8di)  &__X, ( &__v8di)  &__Y, ( &__mmask8)  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_madd52lo_epu64 ( &__mmask8  &__M,  &__m512i  &__X,  &__m512i  &__Y,  &__m512i  &__Z) { ( &__m512i)  &__builtin_ia32_vpmadd52luq512_maskz (( &__v8di)  &__X, ( &__v8di)  &__Y, ( &__v8di)  &__Z, ( &__mmask8)  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_madd52hi_epu64 ( &__mmask8  &__M,  &__m512i  &__X,  &__m512i  &__Y,  &__m512i  &__Z) { ( &__m512i)  &__builtin_ia32_vpmadd52huq512_maskz (( &__v8di)  &__X, ( &__v8di)  &__Y, ( &__v8di)  &__Z, ( &__mmask8)  &__M); });
    }' unless defined(&__attribute__);
    if(defined(&__DISABLE_AVX512IFMA__)) {
	undef(&__DISABLE_AVX512IFMA__) if defined(&__DISABLE_AVX512IFMA__);
    }
}
1;
