require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_IMMINTRIN_H_INCLUDED)) {
    die("Never use <avx512vnniintrin.h> directly; include <immintrin.h> instead.");
}
unless(defined(&__AVX512VNNIINTRIN_H_INCLUDED)) {
    eval 'sub __AVX512VNNIINTRIN_H_INCLUDED () {1;}' unless defined(&__AVX512VNNIINTRIN_H_INCLUDED);
    if(!defined(&__AVX512VNNI__)) {
	eval 'sub __DISABLE_AVX512VNNI__ () {1;}' unless defined(&__DISABLE_AVX512VNNI__);
    }
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_dpbusd_epi32 ( &__m512i  &__A,  &__m512i  &__B,  &__m512i  &__C) { ( &__m512i)  &__builtin_ia32_vpdpbusd_v16si (( &__v16si) &__A, ( &__v16si)  &__B, ( &__v16si)  &__C); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_dpbusd_epi32 ( &__m512i  &__A,  &__mmask16  &__B,  &__m512i  &__C,  &__m512i  &__D) { ( &__m512i) &__builtin_ia32_vpdpbusd_v16si_mask (( &__v16si) &__A, ( &__v16si)  &__C, ( &__v16si)  &__D, ( &__mmask16) &__B); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_dpbusd_epi32 ( &__mmask16  &__A,  &__m512i  &__B,  &__m512i  &__C,  &__m512i  &__D) { ( &__m512i) &__builtin_ia32_vpdpbusd_v16si_maskz (( &__v16si) &__B, ( &__v16si)  &__C, ( &__v16si)  &__D, ( &__mmask16) &__A); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_dpbusds_epi32 ( &__m512i  &__A,  &__m512i  &__B,  &__m512i  &__C) { ( &__m512i)  &__builtin_ia32_vpdpbusds_v16si (( &__v16si) &__A, ( &__v16si)  &__B, ( &__v16si)  &__C); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_dpbusds_epi32 ( &__m512i  &__A,  &__mmask16  &__B,  &__m512i  &__C,  &__m512i  &__D) { ( &__m512i) &__builtin_ia32_vpdpbusds_v16si_mask (( &__v16si) &__A, ( &__v16si)  &__C, ( &__v16si)  &__D, ( &__mmask16) &__B); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_dpbusds_epi32 ( &__mmask16  &__A,  &__m512i  &__B,  &__m512i  &__C,  &__m512i  &__D) { ( &__m512i) &__builtin_ia32_vpdpbusds_v16si_maskz (( &__v16si) &__B, ( &__v16si)  &__C, ( &__v16si)  &__D, ( &__mmask16) &__A); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_dpwssd_epi32 ( &__m512i  &__A,  &__m512i  &__B,  &__m512i  &__C) { ( &__m512i)  &__builtin_ia32_vpdpwssd_v16si (( &__v16si) &__A, ( &__v16si)  &__B, ( &__v16si)  &__C); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_dpwssd_epi32 ( &__m512i  &__A,  &__mmask16  &__B,  &__m512i  &__C,  &__m512i  &__D) { ( &__m512i) &__builtin_ia32_vpdpwssd_v16si_mask (( &__v16si) &__A, ( &__v16si)  &__C, ( &__v16si)  &__D, ( &__mmask16) &__B); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_dpwssd_epi32 ( &__mmask16  &__A,  &__m512i  &__B,  &__m512i  &__C,  &__m512i  &__D) { ( &__m512i) &__builtin_ia32_vpdpwssd_v16si_maskz (( &__v16si) &__B, ( &__v16si)  &__C, ( &__v16si)  &__D, ( &__mmask16) &__A); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_dpwssds_epi32 ( &__m512i  &__A,  &__m512i  &__B,  &__m512i  &__C) { ( &__m512i)  &__builtin_ia32_vpdpwssds_v16si (( &__v16si) &__A, ( &__v16si)  &__B, ( &__v16si)  &__C); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_dpwssds_epi32 ( &__m512i  &__A,  &__mmask16  &__B,  &__m512i  &__C,  &__m512i  &__D) { ( &__m512i) &__builtin_ia32_vpdpwssds_v16si_mask (( &__v16si) &__A, ( &__v16si)  &__C, ( &__v16si)  &__D, ( &__mmask16) &__B); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_dpwssds_epi32 ( &__mmask16  &__A,  &__m512i  &__B,  &__m512i  &__C,  &__m512i  &__D) { ( &__m512i) &__builtin_ia32_vpdpwssds_v16si_maskz (( &__v16si) &__B, ( &__v16si)  &__C, ( &__v16si)  &__D, ( &__mmask16) &__A); });
    }' unless defined(&__attribute__);
    if(defined(&__DISABLE_AVX512VNNI__)) {
	undef(&__DISABLE_AVX512VNNI__) if defined(&__DISABLE_AVX512VNNI__);
    }
}
1;
