require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_X86INTRIN_H_INCLUDED)) {
    die("Never use <lwpintrin.h> directly; include <x86intrin.h> instead.");
}
unless(defined(&_LWPINTRIN_H_INCLUDED)) {
    eval 'sub _LWPINTRIN_H_INCLUDED () {1;}' unless defined(&_LWPINTRIN_H_INCLUDED);
    unless(defined(&__LWP__)) {
	eval 'sub __DISABLE_LWP__ () {1;}' unless defined(&__DISABLE_LWP__);
    }
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &__llwpcb ( &void * &__pcbAddress) {  &__builtin_ia32_llwpcb ( &__pcbAddress); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &__slwpcb ( &void) {  &__builtin_ia32_slwpcb (); });
    }' unless defined(&__attribute__);
    if(defined(&__OPTIMIZE__)) {
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &__lwpval32 (my $__data2, my $__data1, my $__flags) {  &__builtin_ia32_lwpval32 ( $__data2,  $__data1,  $__flags); });
	}' unless defined(&__attribute__);
	if(defined(&__x86_64__)) {
	    eval 'sub __attribute__ () {
	        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &__lwpval64 (my $__data2, my $__data1, my $__flags) {  &__builtin_ia32_lwpval64 ( $__data2,  $__data1,  $__flags); });
	    }' unless defined(&__attribute__);
	}
    } else {
	eval 'sub __lwpval32 {
	    my($D2, $D1, $F) = @_;
    	    eval q(( &__builtin_ia32_lwpval32 ( , , ($F))));
	}' unless defined(&__lwpval32);
	if(defined(&__x86_64__)) {
	    eval 'sub __lwpval64 {
	        my($D2, $D1, $F) = @_;
    		eval q(( &__builtin_ia32_lwpval64 ( , , ($F))));
	    }' unless defined(&__lwpval64);
	}
    }
    if(defined(&__OPTIMIZE__)) {
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &__lwpins32 (my $__data2, my $__data1, my $__flags) {  &__builtin_ia32_lwpins32 ( $__data2,  $__data1,  $__flags); });
	}' unless defined(&__attribute__);
	if(defined(&__x86_64__)) {
	    eval 'sub __attribute__ () {
	        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &__lwpins64 (my $__data2, my $__data1, my $__flags) {  &__builtin_ia32_lwpins64 ( $__data2,  $__data1,  $__flags); });
	    }' unless defined(&__attribute__);
	}
    } else {
	eval 'sub __lwpins32 {
	    my($D2, $D1, $F) = @_;
    	    eval q(( &__builtin_ia32_lwpins32 ( , , ($F))));
	}' unless defined(&__lwpins32);
	if(defined(&__x86_64__)) {
	    eval 'sub __lwpins64 {
	        my($D2, $D1, $F) = @_;
    		eval q(( &__builtin_ia32_lwpins64 ( , , ($F))));
	    }' unless defined(&__lwpins64);
	}
    }
    if(defined(&__DISABLE_LWP__)) {
	undef(&__DISABLE_LWP__) if defined(&__DISABLE_LWP__);
    }
}
1;
