require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_PMMINTRIN_H_INCLUDED)) {
    eval 'sub _PMMINTRIN_H_INCLUDED () {1;}' unless defined(&_PMMINTRIN_H_INCLUDED);
    require 'emmintrin.ph';
    unless(defined(&__SSE3__)) {
	eval 'sub __DISABLE_SSE3__ () {1;}' unless defined(&__DISABLE_SSE3__);
    }
    eval 'sub _MM_DENORMALS_ZERO_MASK () {0x40;}' unless defined(&_MM_DENORMALS_ZERO_MASK);
    eval 'sub _MM_DENORMALS_ZERO_ON () {0x40;}' unless defined(&_MM_DENORMALS_ZERO_ON);
    eval 'sub _MM_DENORMALS_ZERO_OFF () {0x;}' unless defined(&_MM_DENORMALS_ZERO_OFF);
    eval 'sub _MM_SET_DENORMALS_ZERO_MODE {
        my($mode) = @_;
	    eval q( &_mm_setcsr (( &_mm_getcsr () & ~ &_MM_DENORMALS_ZERO_MASK) | ($mode)));
    }' unless defined(&_MM_SET_DENORMALS_ZERO_MODE);
    eval 'sub _MM_GET_DENORMALS_ZERO_MODE () {
        eval q(( &_mm_getcsr() &  &_MM_DENORMALS_ZERO_MASK));
    }' unless defined(&_MM_GET_DENORMALS_ZERO_MODE);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_addsub_ps ( &__m128  &__X,  &__m128  &__Y) { ( &__m128)  &__builtin_ia32_addsubps (( &__v4sf) &__X, ( &__v4sf) &__Y); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_hadd_ps ( &__m128  &__X,  &__m128  &__Y) { ( &__m128)  &__builtin_ia32_haddps (( &__v4sf) &__X, ( &__v4sf) &__Y); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_hsub_ps ( &__m128  &__X,  &__m128  &__Y) { ( &__m128)  &__builtin_ia32_hsubps (( &__v4sf) &__X, ( &__v4sf) &__Y); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_movehdup_ps ( &__m128  &__X) { ( &__m128)  &__builtin_ia32_movshdup (( &__v4sf) &__X); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_moveldup_ps ( &__m128  &__X) { ( &__m128)  &__builtin_ia32_movsldup (( &__v4sf) &__X); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_addsub_pd ( &__m128d  &__X,  &__m128d  &__Y) { ( &__m128d)  &__builtin_ia32_addsubpd (( &__v2df) &__X, ( &__v2df) &__Y); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_hadd_pd ( &__m128d  &__X,  &__m128d  &__Y) { ( &__m128d)  &__builtin_ia32_haddpd (( &__v2df) &__X, ( &__v2df) &__Y); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_hsub_pd ( &__m128d  &__X,  &__m128d  &__Y) { ( &__m128d)  &__builtin_ia32_hsubpd (( &__v2df) &__X, ( &__v2df) &__Y); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_loaddup_pd (\'double\'  &const * &__P) {  &_mm_load1_pd ( &__P); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_movedup_pd ( &__m128d  &__X) {  &_mm_shuffle_pd ( &__X,  &__X,  &_MM_SHUFFLE2 (0,0)); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_lddqu_si128 ( &__m128i  &const * &__P) { ( &__m128i)  &__builtin_ia32_lddqu ((\'char\'  &const *) &__P); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_monitor ( &void  &const *  &__P, my $__E, my $__H) {  &__builtin_ia32_monitor ( &__P,  $__E,  $__H); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_mwait (my $__E, my $__H) {  &__builtin_ia32_mwait ( $__E,  $__H); });
    }' unless defined(&__attribute__);
    if(defined(&__DISABLE_SSE3__)) {
	undef(&__DISABLE_SSE3__) if defined(&__DISABLE_SSE3__);
    }
}
1;
