require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_WMMINTRIN_H_INCLUDED)) {
    eval 'sub _WMMINTRIN_H_INCLUDED () {1;}' unless defined(&_WMMINTRIN_H_INCLUDED);
    require 'emmintrin.ph';
    if(!defined(&__AES__) || !defined(&__SSE2__)) {
	eval 'sub __DISABLE_AES__ () {1;}' unless defined(&__DISABLE_AES__);
    }
    if(defined(&__OPTIMIZE__)) {
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_aeskeygenassist_si128 ( &__m128i  &__X,  &const \'int\'  &__C) { ( &__m128i)  &__builtin_ia32_aeskeygenassist128 (( &__v2di) &__X,  &__C); });
	}' unless defined(&__attribute__);
    } else {
	eval 'sub _mm_aeskeygenassist_si128 {
	    my($X, $C) = @_;
    	    eval q((( &__m128i)  &__builtin_ia32_aeskeygenassist128 (( &__v2di)( &__m128i), ($C))));
	}' unless defined(&_mm_aeskeygenassist_si128);
    }
    if(defined(&__DISABLE_AES__)) {
	undef(&__DISABLE_AES__) if defined(&__DISABLE_AES__);
    }
    if(!defined(&__PCLMUL__) || !defined(&__SSE2__)) {
	eval 'sub __DISABLE_PCLMUL__ () {1;}' unless defined(&__DISABLE_PCLMUL__);
    }
    if(defined(&__OPTIMIZE__)) {
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_clmulepi64_si128 ( &__m128i  &__X,  &__m128i  &__Y,  &const \'int\'  &__I) { ( &__m128i)  &__builtin_ia32_pclmulqdq128 (( &__v2di) &__X, ( &__v2di) &__Y,  &__I); });
	}' unless defined(&__attribute__);
    } else {
	eval 'sub _mm_clmulepi64_si128 {
	    my($X, $Y, $I) = @_;
    	    eval q((( &__m128i)  &__builtin_ia32_pclmulqdq128 (( &__v2di)( &__m128i)($X), ( &__v2di)( &__m128i), ($I))));
	}' unless defined(&_mm_clmulepi64_si128);
    }
    if(defined(&__DISABLE_PCLMUL__)) {
	undef(&__DISABLE_PCLMUL__) if defined(&__DISABLE_PCLMUL__);
    }
}
1;
