require '_h2ph_pre.ph';

no warnings qw(redefine misc);

if(!defined (&_IMMINTRIN_H_INCLUDED)) {
    die("Never use <xsaveoptintrin.h> directly; include <immintrin.h> instead.");
}
unless(defined(&_XSAVEOPTINTRIN_H_INCLUDED)) {
    eval 'sub _XSAVEOPTINTRIN_H_INCLUDED () {1;}' unless defined(&_XSAVEOPTINTRIN_H_INCLUDED);
    unless(defined(&__XSAVEOPT__)) {
	eval 'sub __DISABLE_XSAVEOPT__ () {1;}' unless defined(&__DISABLE_XSAVEOPT__);
    }
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_xsaveopt ( &void * &__P, my $__M) {  &__builtin_ia32_xsaveopt ( &__P,  $__M); });
    }' unless defined(&__attribute__);
    if(defined(&__x86_64__)) {
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_xsaveopt64 ( &void * &__P, my $__M) {  &__builtin_ia32_xsaveopt64 ( &__P,  $__M); });
	}' unless defined(&__attribute__);
    }
    if(defined(&__DISABLE_XSAVEOPT__)) {
	undef(&__DISABLE_XSAVEOPT__) if defined(&__DISABLE_XSAVEOPT__);
    }
}
1;
