require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_X86_FENV_H_)) {
    eval 'sub _X86_FENV_H_ () {1;}' unless defined(&_X86_FENV_H_);
    unless(defined(&_KERNEL)) {
	require 'sys/stdint.ph';
    }
    eval 'sub __INITIAL_NPXCW__ () {0x37f;}' unless defined(&__INITIAL_NPXCW__);
    eval 'sub __NetBSD_NPXCW__ () { &__INITIAL_NPXCW__;}' unless defined(&__NetBSD_NPXCW__);
    eval 'sub __NetBSD_COMPAT_NPXCW__ () {0x127f;}' unless defined(&__NetBSD_COMPAT_NPXCW__);
    eval 'sub __INITIAL_MXCSR__ () {0x1f80;}' unless defined(&__INITIAL_MXCSR__);
    unless(defined(&_KERNEL)) {
	eval 'sub FE_INVALID () {0x1;}' unless defined(&FE_INVALID);
	eval 'sub FE_DENORMAL () {0x2;}' unless defined(&FE_DENORMAL);
	eval 'sub FE_DIVBYZERO () {0x4;}' unless defined(&FE_DIVBYZERO);
	eval 'sub FE_OVERFLOW () {0x8;}' unless defined(&FE_OVERFLOW);
	eval 'sub FE_UNDERFLOW () {0x10;}' unless defined(&FE_UNDERFLOW);
	eval 'sub FE_INEXACT () {0x20;}' unless defined(&FE_INEXACT);
	eval 'sub FE_ALL_EXCEPT () {( &FE_DIVBYZERO |  &FE_DENORMAL |  &FE_INEXACT |  &FE_INVALID |  &FE_OVERFLOW |  &FE_UNDERFLOW);}' unless defined(&FE_ALL_EXCEPT);
	eval 'sub FE_TONEAREST () {0x;}' unless defined(&FE_TONEAREST);
	eval 'sub FE_DOWNWARD () {0x400;}' unless defined(&FE_DOWNWARD);
	eval 'sub FE_UPWARD () {0x800;}' unless defined(&FE_UPWARD);
	eval 'sub FE_TOWARDZERO () {0xc00;}' unless defined(&FE_TOWARDZERO);
	eval 'sub __X87_ROUND_MASK () {0xc00;}' unless defined(&__X87_ROUND_MASK);
	eval 'sub __SSE_ROUND_SHIFT () {3;}' unless defined(&__SSE_ROUND_SHIFT);
	eval 'sub __SSE_EMASK_SHIFT () {7;}' unless defined(&__SSE_EMASK_SHIFT);
	eval 'sub FE_DFL_ENV () {(( &const  &fenv_t *) & &__fe_dfl_env);}' unless defined(&FE_DFL_ENV);
    }
}
1;
