require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_I386_MCONTEXT_H_)) {
    eval 'sub _I386_MCONTEXT_H_ () {1;}' unless defined(&_I386_MCONTEXT_H_);
    eval 'sub _UC_SETSTACK () {0x10000;}' unless defined(&_UC_SETSTACK);
    eval 'sub _UC_CLRSTACK () {0x20000;}' unless defined(&_UC_CLRSTACK);
    eval 'sub _UC_VM () {0x40000;}' unless defined(&_UC_VM);
    eval 'sub _UC_TLSBASE () {0x80000;}' unless defined(&_UC_TLSBASE);
    eval 'sub _NGREG () {19;}' unless defined(&_NGREG);
    eval 'sub _REG_GS () {0;}' unless defined(&_REG_GS);
    eval 'sub _REG_FS () {1;}' unless defined(&_REG_FS);
    eval 'sub _REG_ES () {2;}' unless defined(&_REG_ES);
    eval 'sub _REG_DS () {3;}' unless defined(&_REG_DS);
    eval 'sub _REG_EDI () {4;}' unless defined(&_REG_EDI);
    eval 'sub _REG_ESI () {5;}' unless defined(&_REG_ESI);
    eval 'sub _REG_EBP () {6;}' unless defined(&_REG_EBP);
    eval 'sub _REG_ESP () {7;}' unless defined(&_REG_ESP);
    eval 'sub _REG_EBX () {8;}' unless defined(&_REG_EBX);
    eval 'sub _REG_EDX () {9;}' unless defined(&_REG_EDX);
    eval 'sub _REG_ECX () {10;}' unless defined(&_REG_ECX);
    eval 'sub _REG_EAX () {11;}' unless defined(&_REG_EAX);
    eval 'sub _REG_TRAPNO () {12;}' unless defined(&_REG_TRAPNO);
    eval 'sub _REG_ERR () {13;}' unless defined(&_REG_ERR);
    eval 'sub _REG_EIP () {14;}' unless defined(&_REG_EIP);
    eval 'sub _REG_CS () {15;}' unless defined(&_REG_CS);
    eval 'sub _REG_EFL () {16;}' unless defined(&_REG_EFL);
    eval 'sub _REG_UESP () {17;}' unless defined(&_REG_UESP);
    eval 'sub _REG_SS () {18;}' unless defined(&_REG_SS);
    eval 'sub _UC_FXSAVE () {0x20;}' unless defined(&_UC_FXSAVE);
    eval 'sub _UC_MACHINE_PAD () {4;}' unless defined(&_UC_MACHINE_PAD);
    eval 'sub _UC_UCONTEXT_ALIGN () {(~0xf);}' unless defined(&_UC_UCONTEXT_ALIGN);
    unless(defined(&_UC_MACHINE_SP)) {
	eval 'sub _UC_MACHINE_SP {
	    my($uc) = @_;
    	    eval q((($uc)-> ($uc_mcontext->{__gregs[&_REG_UESP]})));
	}' unless defined(&_UC_MACHINE_SP);
    }
    eval 'sub _UC_MACHINE_FP {
        my($uc) = @_;
	    eval q((($uc)-> ($uc_mcontext->{__gregs[&_REG_EBP]})));
    }' unless defined(&_UC_MACHINE_FP);
    eval 'sub _UC_MACHINE_PC {
        my($uc) = @_;
	    eval q((($uc)-> ($uc_mcontext->{__gregs[&_REG_EIP]})));
    }' unless defined(&_UC_MACHINE_PC);
    eval 'sub _UC_MACHINE_INTRV {
        my($uc) = @_;
	    eval q((($uc)-> ($uc_mcontext->{__gregs[&_REG_EAX]})));
    }' unless defined(&_UC_MACHINE_INTRV);
    eval 'sub _UC_MACHINE_SET_PC {
        my($uc, $pc) = @_;
	    eval q( &_UC_MACHINE_PC($uc) = ($pc));
    }' unless defined(&_UC_MACHINE_SET_PC);
    eval 'sub __UCONTEXT_SIZE () {776;}' unless defined(&__UCONTEXT_SIZE);
    if(defined(&_RTLD_SOURCE) || defined(&_LIBC_SOURCE) || defined(&__LIBPTHREAD_SOURCE__)) {
	require 'sys/tls.ph';
	eval 'sub __lwp_getprivate_fast {
	    my($void) = @_;
    	    eval q({ $void * &__tmp;  &__asm  &volatile(\\"movl %%gs:0, %0\\" : \\"=r\\" ( &__tmp));  &__tmp; });
	}' unless defined(&__lwp_getprivate_fast);
    }
}
1;
