require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_X86_LOCK_H_)) {
    eval 'sub _X86_LOCK_H_ () {1;}' unless defined(&_X86_LOCK_H_);
    require 'sys/param.ph';
    eval 'sub __SIMPLELOCK_LOCKED_P {
        my($__ptr) = @_;
	    eval q({ *$__ptr ==  &__SIMPLELOCK_LOCKED; });
    }' unless defined(&__SIMPLELOCK_LOCKED_P);
    eval 'sub __SIMPLELOCK_UNLOCKED_P {
        my($__ptr) = @_;
	    eval q({ *$__ptr ==  &__SIMPLELOCK_UNLOCKED; });
    }' unless defined(&__SIMPLELOCK_UNLOCKED_P);
    eval 'sub __cpu_simple_lock_set {
        my($__ptr) = @_;
	    eval q({ *$__ptr =  &__SIMPLELOCK_LOCKED; });
    }' unless defined(&__cpu_simple_lock_set);
    eval 'sub __cpu_simple_lock_clear {
        my($__ptr) = @_;
	    eval q({ *$__ptr =  &__SIMPLELOCK_UNLOCKED; });
    }' unless defined(&__cpu_simple_lock_clear);
    if(defined(&_HARDKERNEL)) {
	require 'machine/cpufunc.ph';
	eval 'sub SPINLOCK_SPIN_HOOK () {1;}' unless defined(&SPINLOCK_SPIN_HOOK);
	if(defined(&SPINLOCK_BACKOFF_HOOK)) {
	    undef(&SPINLOCK_BACKOFF_HOOK) if defined(&SPINLOCK_BACKOFF_HOOK);
	}
	eval 'sub SPINLOCK_BACKOFF_HOOK () { &x86_pause();}' unless defined(&SPINLOCK_BACKOFF_HOOK);
	eval 'sub SPINLOCK_INLINE () {1;}' unless defined(&SPINLOCK_INLINE);
    } else {
	eval 'sub SPINLOCK_BODY () {1;}' unless defined(&SPINLOCK_BODY);
	eval 'sub SPINLOCK_INLINE () { &static  &__inline  &__unused;}' unless defined(&SPINLOCK_INLINE);
    }
    if(defined(&SPINLOCK_BODY)) {
    }
}
1;
